<?php

class IndexController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
    }

    public function indexAction()
    {
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax consultant near me Sonipat, best income tax advisor Haryana, affordable GST filing services Delhi NCR, tax audit expert in Sonipat, TDS return consultant Haryana, Book an Appointment for Consultation'); 
        $layout->assign('meta_desc', 'Book an Appointment with M Goswami & Assiciates for tax consultation or any type of Business solution or Legal service.');
        $layout->assign('page_title', 'Welcome to M Goswami & Associates');
    }
    
    public function contactAction()
    {
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax consultant near me Sonipat, best income tax advisor Haryana, affordable GST filing services Delhi NCR, tax audit expert in Sonipat, TDS return consultant Haryana, Contact us for any concern or query'); 
        $layout->assign('meta_desc', 'Contact to M Goswami & Associates team for tax consultation or any type of Business solution or Legal service.');
        $layout->assign('page_title', 'Contact Us');
        
        if($this->getRequest()->isPost()) {
            
            $data = $this->getRequest()->getPost();
            $msg = new Zend_Session_Namespace('msg');
            $cname = $data['cname'];
            $email = $data['email'];
            $phone = $data['phone'];
            $message = $data['message'];
            $list = ($data['listId'] > 0) ? $data['listId'] : 0;
            
            $obj_contact = new Application_Model_ContactLogic(-1);
            $obj_contact->insertContact($cname, $email, $phone, $message, $list);
            
            if(empty($list)) {
                $msg->msg = "Your message was sent succssfully! We will be in touch as soon as possible.";
                $this->_redirect('contact-us');
            }else {
                $this->_redirect('list/report/abuse/'.$enc->hideContent($data['listId']));
            }
        }
        
    }
    
    public function appointmentAction()
    {
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax consultant near me Sonipat, best income tax advisor Haryana, affordable GST filing services Delhi NCR, tax audit expert in Sonipat, TDS return consultant Haryana, Book an Appointment for Consultation'); 
        $layout->assign('meta_desc', 'Book an Appointment with M Goswami & Associates for tax consultation or any type of Business solution or Legal service.');
        $layout->assign('page_title', 'Book an Appointment');
        
        if($this->getRequest()->isPost()) {
            
            $data = $this->getRequest()->getPost();
            Zend_Debug::dump($data);
            $msg = new Zend_Session_Namespace('msg');
            $cname = $data['cname'];
            $email = $data['mail'];
            $phone = $data['phone'];
            $dt = date('Y-m-d H:i:s', strtotime($data['dt']));
            $subject = $data['subject'];
            $service = $data['service'];
            $message = $data['massage'];
            
            $obj_appoint = new Application_Model_AppointmentLogic(-1);
            $obj_appoint->set_appointment_name($cname);
            $obj_appoint->set_appointment_email($email);
            $obj_appoint->set_appointment_phone($phone);
            $obj_appoint->set_appointment_date($dt);
            $obj_appoint->set_appointment_service($service);
            $obj_appoint->set_appointment_subject($subject);
            $obj_appoint->set_appointment_message($message);
            $obj_appoint->set_appointment_confirm(false);
            $obj_appoint->set_appointment_remarks('');
            $obj_appoint->set_appointment_status('A');
            $obj_appoint->set_appointment_updated_by(0);
            $obj_appoint->save();
            
            
            $msg->msg = "Your request for appointment sent succssfully! You'll receive an email with confirmation soon.";
            //$this->_redirect('appointment');
        }
        
    }
    
    

    public function loginAction()
    {
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax consultant near me Sonipat, best income tax advisor Haryana, affordable GST filing services Delhi NCR, tax audit expert in Sonipat, TDS return consultant Haryana, Contact us for any concern or query'); 
        $layout->assign('meta_desc', 'Contact to M Goswami & Associates team for tax consultation or any type of Business solution or Legal service.');
        $layout->assign('page_title', 'Login');
        
        $sess = new Zend_Session_Namespace('msg');
        $usess = new Zend_Session_Namespace('user');
        if(Zend_Auth::getInstance()->hasIdentity() && !empty($usess->user_name)) {
            $this->_redirect('manage/dashboard');
        }
        
        if($this->getRequest()->isPost()) {
            $data = $this->getRequest()->getPost();
            $uname = $this->_getParam('username');
            $paswd = $this->_getParam('password');
            $obj_auth = new Application_Model_UserLogic(-1);
            $check = $obj_auth->is_user_authenticated($uname, $paswd);
            if($check){
                $obj_user = new Application_Model_UserLogic(-1);
                $logginUser = $obj_user->getLoggedInUser();
                $user = ($logginUser != null) ? new Application_Model_UserLogic($logginUser->get_id()) : null;
                if($user->get_user_status() == 'B') {
                    $obj_user->logout();
                    $sess->error = "Your account has been blocked. Please contact to administrator.";
                    $this->_redirect('login');
                }
                else {
                    $sess->msg = "You have successfully logged in.";
                    $this->_redirect('manage/dashboard');
                }
            }
            else{
                $sess->error = "Wrong User ID or Password, Please Reenter!";
                $this->_redirect('login');
            }
        }
    }
    
    public function logoutAction()
    {
        $auth = Zend_Auth::getInstance(); 
        if(!$auth->hasIdentity()){ 
           $sess = new Zend_Session_Namespace('msg');
           $sess->error = "You session already expired, Please login!";
           $this->_redirect("index");
        }
        $sess = new Zend_Session_Namespace('user');
        unset($sess->id);
        unset($sess->user_id);
        Zend_Session::namespaceUnset('user');
        $auth->clearIdentity();
        $sess = new Zend_Session_Namespace('msg');
        $sess->msg = "You have successfully logout.";
        $this->_redirect('index');
    }

    public function chpwdAction()
    {
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'tax consultant near me Sonipat, best income tax advisor Haryana, affordable GST filing services Delhi NCR, tax audit expert in Sonipat, TDS return consultant Haryana, Contact us for any concern or query'); 
        $layout->assign('meta_desc', 'Contact to M Goswami & Associates team for tax consultation or any type of Business solution or Legal service.');
        $layout->assign('page_title', 'Change Password');
        $auth = Zend_Auth::getInstance(); 
        if($auth->hasIdentity()){ 
            $chpwdForm = new Application_Form_Chpwd();
            $this->view->form = $chpwdForm;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();    
                if($chpwdForm->isValid($data)){
                    $iden = new Zend_Session_Namespace('user');
                    $obj_login = new Application_Model_User($iden->id);
                    $cred = $obj_login->get_user_password();
                    $oldpwd = $chpwdForm->old_pwd->getValue();
                    $newpwd = $chpwdForm->new_pwd->getValue();
                    $repwd = $chpwdForm->re_new_pwd->getValue();
                    if($cred == sha1($oldpwd)){
                        if($newpwd == $repwd){
                            $mpwd = sha1($newpwd);
                            $obj_login->set_user_password($mpwd);
                            $obj_login->save();
                            $sess = new Zend_Session_Namespace('msg');
                            $sess->msg = "You Have Successfully Change Your Password!!!";
                            $this->_redirect('index/chpwd');
                        }
                        else{
                            $sess = new Zend_Session_Namespace('msg');
                            $sess->error = "Your Password Not Match!!!";
                            $this->_redirect('index/chpwd');
                        }
                    }
                    else{
                        $sess = new Zend_Session_Namespace('msg');
                        $sess->error = "You Enter Wrong Old Password!!!";
                        $this->_redirect('index/chpwd');
                    }
                }    
            }
        } 
        else { 
           $sess = new Zend_Session_Namespace('msg');
           $sess->error = "You are not authorize person, Please login!";
           $this->_redirect("index/index");
        }
    }
    
    public function testimonialAction() 
    {
        $obj_tm = new Application_Model_TestimonialLogic(-1);
        $this->view->testimonials = $obj_tm->fetchOrdered();
    }
    
}

