<?php

/**
 * Zend Form implementing a form to process the data.
 *
 * Asit expert Data Process via this form.
 *
 * @package Sakshi Infotech Code
 * @name Asit expert Form
 * @filesource application/model
 * @author Akhil Gupta
 * @copyright Sakshi Infotech
 * @version 1.0
 * @license Sakshi Infotech
 * @subpackage Zend_Forms
 */
class Application_Form_Expert extends Zend_Form
{
    
    /**
     * Method initialize form fields of asit_expert table
     *
     * @var varchar expert_title
     * @var varchar expert_image
     * @var varchar expert_short_desc
     * @var text expert_desc
     * @var varchar expert_url
     * @var varchar expert_meta_key
     * @var varchar expert_meta_desc
     * @var varchar expert_status
     * @var int expert_updated_by
     * @var timestamp expert_updated_date
     * @var int expert_created_by
     * @var timestamp expert_created_date
     */
    public function init()
    {
        $token = new Zend_Form_Element_Hash("token");
        $obj_base = new Zend_View_Helper_BaseUrl();
        
        echo "<script type='text/javascript'> CKEDITOR.replace( 'expert_desc',{fullExpert : true,width: 650,filebrowserBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserImageBrowseUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Image&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserFlashBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Flash&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserUploadUrl  :'".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=File')."',
                filebrowserImageUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Image')."',
                filebrowserFlashUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Flash')."'});</script>";
        
        
        $expert_title = new Zend_Form_Element_Text("expert_title");
        $expert_title->setLabel("Title")->setRequired(true);
        
        $expert_image = new Zend_Form_Element_File("expert_image");
        $expert_image->setLabel("Feature Image")->setRequired(true);
        $filename = date('d_M_y_H_i_s') . '_expert_' . ((null != $expert_image->getFileName(null, false)) ? $expert_image->getFileName(null, false) : '');
        $expert_image->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME') . '/' . Application_Model_Cache_Config::getConfig('PAGE_FOLDER') . '/')
        ->addFilter('Rename', $filename)
        //->addValidator('Size', false, Application_Model_Cache_Config::getConfig('MAXIMUM_UPLOAD_SIZE_LIBRARY'))
        ->addValidator('Extension', false, Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS'))
        ->setDescription('Only ' . Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS') . ' files allowed');
        
        $expert_short_desc = new Zend_Form_Element_Textarea("expert_short_desc");
        $expert_short_desc->setLabel("Short Description")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $expert_desc = new Zend_Form_Element_Textarea("expert_desc");
        $expert_desc->setLabel("Description")->setRequired(true);
        
        $expert_meta_key = new Zend_Form_Element_Textarea("expert_meta_key");
        $expert_meta_key->setLabel("Meta Key")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $expert_meta_desc = new Zend_Form_Element_Textarea("expert_meta_desc");
        $expert_meta_desc->setLabel("Meta Description")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $expert_status = new Zend_Form_Element_Radio("expert_status");
        $expert_status->setLabel("Status")
        ->setRequired(true)
        ->setSeparator(' ');
        $expert_status->addMultiOption('A', 'Publish');
        $expert_status->addMultiOption('E', 'Draft');
        $expert_status->addMultiOption('B', 'Block');
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")
        ->setRequired(true)
        ->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array(
            $token,
            $expert_title,
            $expert_image,
            $expert_short_desc,
            $expert_desc,
            $expert_meta_key,
            $expert_meta_desc,
            $expert_status,
            $save
        ));
    }
}
