<?php
class Application_Form_Product extends Zend_Form
{
    
    public function init()
    {
        
        $token = new Zend_Form_Element_Hash("token");
        $token->setTimeout(Application_Model_Cache_Config::getConfig("FORM_CSRF_TOKEN_EXPIRE"));
        
        $obj_base = new Zend_View_Helper_BaseUrl();
        
        echo "<script type='text/javascript'> CKEDITOR.replace( 'product_desc',{fullPage : true,width: 650,filebrowserBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserImageBrowseUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Image&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserFlashBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Flash&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserUploadUrl  :'".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=File')."',
                filebrowserImageUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Image')."',
                filebrowserFlashUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Flash')."'});</script>";
        
        $product_name = new Zend_Form_Element_Text("product_name");
        $product_name->setLabel("Product Name")->setRequired(true);
        
        $product_tag_line = new Zend_Form_Element_Text("product_tag_line");
        $product_tag_line->setLabel("Tag Line")->setRequired(true);
        
        $product_img = new Zend_Form_Element_File("product_img");
        $product_img->setLabel("Picture")->setRequired(true);
        $filename = date('d_M_y_H_i_s') . '_testimonial_' . ((null != $product_img->getFileName(null, false)) ? $product_img->getFileName(null, false) : '');
        $product_img->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME') . '/product/')
        ->addFilter('Rename', $filename)
        ->addValidator('Size', false, Application_Model_Cache_Config::getConfig('MAXIMUM_UPLOAD_SIZE_LIBRARY'))
        ->addValidator('Extension', false, Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS'))
        ->setDescription('Only ' . Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS') . ' files allowed');
        
        $product_category = new Zend_Form_Element_Select("product_category");
        $product_category->setLabel("Category")->setRequired(true);
        $obj_cat = new Application_Model_CategoryLogic(-1);
        $product_category->addMultiOption('', '-- Select Category --');
        foreach($obj_cat->getCategoryByType('P') as $cat) {
            $product_category->addMultiOption($cat->id, $cat->category_title);
        }
        
        $product_type = new Zend_Form_Element_Select("product_type");
        $product_type->setLabel("Type")->setRequired(true);
        $product_type->addMultiOption('', '-- Select Type --');
        $product_type->addMultiOption('Capsules', 'Capsules');
        $product_type->addMultiOption('Dry Syrup', 'Dry Syrup');
        $product_type->addMultiOption('Suspension', 'Suspension');
        $product_type->addMultiOption('Syrup', 'Syrup');
        $product_type->addMultiOption('Tablets', 'Tablets');
        
        $product_qty = new Zend_Form_Element_Text("product_qty");
        $product_qty->setLabel("Quantity")->setRequired(true);
        
        $product_desc = new Zend_Form_Element_Textarea("product_desc");
        $product_desc->setLabel("Description")->setRequired(true);
        
        $product_uses = new Zend_Form_Element_Textarea("product_uses");
        $product_uses->setLabel("Uses")->setRequired(true)->setAttrib('class', 'cleditor');
        
        $product_action = new Zend_Form_Element_Textarea("product_action");
        $product_action->setLabel("Action")->setRequired(true)->setAttrib('class', 'cleditor');
        
        $product_precaution = new Zend_Form_Element_Textarea("product_precaution");
        $product_precaution->setLabel("Precaution")->setRequired(true)->setAttrib('class', 'cleditor');
        
        $product_side_effect = new Zend_Form_Element_Textarea("product_side_effect");
        $product_side_effect->setLabel("Side Effect")->setRequired(true)->setAttrib('class', 'cleditor');
        
        $product_meta_key = new Zend_Form_Element_Textarea("product_meta_key");
        $product_meta_key->setLabel("Meta Key")->setRequired(true)->setAttrib('rows', 5);
        
        $product_meta_desc = new Zend_Form_Element_Textarea("product_meta_desc");
        $product_meta_desc->setLabel("Meta Desc")->setRequired(true)->setAttrib('rows', 5);
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $product_name,
        $product_tag_line,
        $product_img,
        $product_category,
        $product_type,
        $product_qty,
        $product_desc,
        $product_uses,
        $product_action,
        $product_precaution,
        $product_side_effect,
        $product_meta_key,
        $product_meta_desc,
        $save));
    }
    
    
}