<?php

/**
 * Zend Form implementing a form to process the data.
 *
 * Asit service Data Process via this form.
 *
 * @package Sakshi Infotech Code
 * @name Asit service Form
 * @filesource application/model
 * @author Akhil Gupta
 * @copyright Sakshi Infotech
 * @version 1.0
 * @license Sakshi Infotech
 * @subpackage Zend_Forms
 */
class Application_Form_Service extends Zend_Form
{
    
    /**
     * Method initialize form fields of asit_service table
     *
     * @var varchar service_title
     * @var varchar service_image
     * @var varchar service_short_desc
     * @var text service_desc
     * @var varchar service_url
     * @var varchar service_meta_key
     * @var varchar service_meta_desc
     * @var varchar service_status
     * @var int service_updated_by
     * @var timestamp service_updated_date
     * @var int service_created_by
     * @var timestamp service_created_date
     */
    public function init()
    {
        $token = new Zend_Form_Element_Hash("token");
        $obj_base = new Zend_View_Helper_BaseUrl();
        
        echo "<script type='text/javascript'> CKEDITOR.replace( 'service_desc',{fullService : true,width: 650,filebrowserBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserImageBrowseUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Image&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserFlashBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Flash&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserUploadUrl  :'".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=File')."',
                filebrowserImageUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Image')."',
                filebrowserFlashUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Flash')."'});</script>";
        
        
        $service_title = new Zend_Form_Element_Text("service_title");
        $service_title->setLabel("Title")->setRequired(true);
        
        $service_image = new Zend_Form_Element_File("service_image");
        $service_image->setLabel("Feature Image")->setRequired(true);
        $filename = date('d_M_y_H_i_s') . '_service_' . ((null != $service_image->getFileName(null, false)) ? $service_image->getFileName(null, false) : '');
        $service_image->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME') . '/' . Application_Model_Cache_Config::getConfig('PAGE_FOLDER') . '/')
        ->addFilter('Rename', $filename)
        //->addValidator('Size', false, Application_Model_Cache_Config::getConfig('MAXIMUM_UPLOAD_SIZE_LIBRARY'))
        ->addValidator('Extension', false, Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS'))
        ->setDescription('Only ' . Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS') . ' files allowed');
        
        $service_short_desc = new Zend_Form_Element_Textarea("service_short_desc");
        $service_short_desc->setLabel("Short Description")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $service_desc = new Zend_Form_Element_Textarea("service_desc");
        $service_desc->setLabel("Description")->setRequired(true);
        
        $service_meta_key = new Zend_Form_Element_Textarea("service_meta_key");
        $service_meta_key->setLabel("Meta Key")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $service_meta_desc = new Zend_Form_Element_Textarea("service_meta_desc");
        $service_meta_desc->setLabel("Meta Description")
        ->setRequired(true)
        ->setAttrib('rows', 5);
        
        $service_status = new Zend_Form_Element_Radio("service_status");
        $service_status->setLabel("Status")
        ->setRequired(true)
        ->setSeparator(' ');
        $service_status->addMultiOption('A', 'Publish');
        $service_status->addMultiOption('E', 'Draft');
        $service_status->addMultiOption('B', 'Block');
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")
        ->setRequired(true)
        ->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array(
            $token,
            $service_title,
            $service_image,
            $service_short_desc,
            $service_desc,
            $service_meta_key,
            $service_meta_desc,
            $service_status,
            $save
        ));
    }
}
