<?php

/**
 * Zend Form implementing a form to process the data.
 *
 * Asit team Data Process via this form.
 *
 * @package Sakshi Infotech Code
 * @linkedin Asit team Form
 * @filesource application/model
 * @author Akhil Gupta
 * @copyright Sakshi Infotech
 * @version 1.0
 * @license Sakshi Infotech
 * @subpackage Zend_Forms
 */
class Application_Form_Team extends Zend_Form
{
    
    /**
     * Method initialize form fields of asit_team table
     *
     * @var varchar team_linkedin
     * @var varchar team_pic
     * @var varchar team_short_desc
     * @var text team_desc
     * @var varchar team_url
     * @var varchar team_meta_key
     * @var varchar team_meta_desc
     * @var varchar team_status
     * @var int team_updated_by
     * @var timestamp team_updated_date
     * @var int team_created_by
     * @var timestamp team_created_date
     */
    public function init()
    {
        $token = new Zend_Form_Element_Hash("token");
        $obj_base = new Zend_View_Helper_BaseUrl();
        
        echo "<script type='text/javascript'> CKEDITOR.replace( 'team_about',{fullPage : true,width: 650,filebrowserBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserImageBrowseUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Image&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserFlashBrowseUrl :'".$obj_base->baseUrl('js/ckeditor/filemanager/browser/default/browser.html')."?Type=Flash&Connector=".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/connector.php')."',
                filebrowserUploadUrl  :'".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=File')."',
                filebrowserImageUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Image')."',
                filebrowserFlashUploadUrl : '".$obj_base->baseUrl('js/ckeditor/filemanager/connectors/php/upload.php?Type=Flash')."'});</script>";
        
        
        $team_name = new Zend_Form_Element_Text("team_name");
        $team_name->setLabel("Name")->setRequired(true);
        
        $team_designation = new Zend_Form_Element_Text("team_designation");
        $team_designation->setLabel("Designation")->setRequired(true);
        
        $team_pic = new Zend_Form_Element_File("team_pic");
        $team_pic->setLabel("Image")->setRequired(true);
        $filelinkedin = date('d_M_y_H_i_s') . '_team_' . ((null != $team_pic->getFileName(null, false)) ? $team_pic->getFileName(null, false) : '');
        $team_pic->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME') . '/' . Application_Model_Cache_Config::getConfig('TEAM_FOLDER') . '/')
        ->addFilter('Rename', $filelinkedin)
        ->addValidator('Size', false, Application_Model_Cache_Config::getConfig('MAXIMUM_UPLOAD_SIZE_LIBRARY'))
        ->addValidator('Extension', false, Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS'))
        ->setDescription('Only ' . Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS') . ' files allowed');
        
        $team_about = new Zend_Form_Element_Textarea("team_about");
        $team_about->setLabel("About")->setRequired(true);
        
        $team_fb = new Zend_Form_Element_Text("team_fb");
        $team_fb->setLabel("FB")->setRequired(true);
        
        $team_tweet = new Zend_Form_Element_Text("team_tweet");
        $team_tweet->setLabel("Tweeter")->setRequired(true);
        
        $team_skype = new Zend_Form_Element_Text("team_skype");
        $team_skype->setLabel("Skype")->setRequired(true);
        
        $team_linkedin = new Zend_Form_Element_Text("team_linkedin");
        $team_linkedin->setLabel("Linked In")->setRequired(true);
        
        $team_order = new Zend_Form_Element_Select("team_order");
        $team_order->setLabel("Order")->setRequired(true);
        for($i=1; $i<=10; $i++) {
            $team_order->addMultiOption($i, $i);
        }
        
        $save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")
        ->setRequired(true)
        ->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array(
            $token,
            $team_name,
            $team_designation, 
            $team_pic,
            $team_about,
            $team_fb,
            $team_tweet,
            $team_skype,
            $team_linkedin,
            $team_order,
            $save
        ));
    }
}
