<?php
/**
 * Zend Form implementing a form to process the data.
 *
 * Asit list review Data Process via this form.
 *
 * @package Sakshi Infotech Code
 * @name Asit list review Form
 * @filesource application/model
 * @author Akhil Gupta
 * @copyright Sakshi Infotech
 * @version 1.0
 * @license Sakshi Infotech
 * @subpackage Zend_Forms
 */
class Application_Form_Testimonial extends Zend_Form
{

    /**
     * Method initialize form fields of asit_list_review table
     *
     * @var int review_list
     * @var int review_user
     * @var tinyint review_score
     * @var varchar review_subject
     * @var text review_body
     * @var varchar review_status
     * @var int review_updated_by
     * @var timestamp review_updated_date
     * @var int review_created_by
     * @var timestamp review_created_date
     */
    public function init()
    {
        $token = new Zend_Form_Element_Hash("token");
        
		$testimonial_name = new Zend_Form_Element_Text("testimonial_name");
        $testimonial_name->setLabel("Name")->setRequired(true);
        
        $testimonial_company = new Zend_Form_Element_Text("testimonial_company");
        $testimonial_company->setLabel("Location")->setRequired(true);
        
        $testimonial_pic = new Zend_Form_Element_File("testimonial_pic");
        $testimonial_pic->setLabel("Picture")->setRequired(true);
        $filename = date('d_M_y_H_i_s') . '_testimonial_' . ((null != $testimonial_pic->getFileName(null, false)) ? $testimonial_pic->getFileName(null, false) : '');
        $testimonial_pic->setDestination(Application_Model_Cache_Config::getConfig('UPLOAD_FOLDER_NAME') . '/' . Application_Model_Cache_Config::getConfig('PAGE_FOLDER') . '/')
        ->addFilter('Rename', $filename)
        ->addValidator('Size', false, Application_Model_Cache_Config::getConfig('MAXIMUM_UPLOAD_SIZE_LIBRARY'))
        ->addValidator('Extension', false, Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS'))
        ->setDescription('Only ' . Application_Model_Cache_Config::getConfig('UPLOAD_IMAGE_EXTENSIONS') . ' files allowed');
		
        $testimonial_content = new Zend_Form_Element_Textarea("testimonial_content");
        $testimonial_content->setLabel("Content")->setRequired(true)->setAttrib('rows', 5);
        
        $testimonial_stars = new Zend_Form_Element_Select("testimonial_stars");
        $testimonial_stars->setLabel("Stars")->setRequired(true);
		$testimonial_stars->addMultiOptions(array("1"=>"1","2"=>"2","3"=>"3","4"=>"4","5"=>"5"));
        
		$save = new Zend_Form_Element_Submit("save");
        $save->setLabel("Save")->setRequired(true)->setAttrib('class', 'btn btn-blue4');
        
        $this->addElements(array($token,
        $testimonial_name,
        $testimonial_company,
        $testimonial_pic,
        $testimonial_content,
        //$testimonial_stars,
        $save));
    }


}
