<?php

class Application_Model_Appointment extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_appointment';

    private $_id = null;

    private $_appointment_name = null;

    private $_appointment_email = null;

    private $_appointment_phone = null;

    private $_appointment_date = null;

    private $_appointment_service = null;

    private $_appointment_subject = null;

    private $_appointment_message = null;

    private $_appointment_confirm = null;

    private $_appointment_remarks = null;

    private $_appointment_status = null;

    private $_appointment_created_date = null;

    private $_appointment_updated_by = null;

    private $_appointment_updated_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get appointment_name method is stand for get the value of appointment_name.
     *
     * @var varchar appointment_name
     */
    public function get_appointment_name()
    {
        return $this->_appointment_name;
    }

    /**
     * set appointment_name method is stand for set the value of appointment_name.
     *
     * @var varchar appointment_name
     */
    public function set_appointment_name($value)
    {
        $this->_appointment_name = $value;
    }

    /**
     * get appointment_email method is stand for get the value of appointment_email.
     *
     * @var varchar appointment_email
     */
    public function get_appointment_email()
    {
        return $this->_appointment_email;
    }

    /**
     * set appointment_email method is stand for set the value of appointment_email.
     *
     * @var varchar appointment_email
     */
    public function set_appointment_email($value)
    {
        $this->_appointment_email = $value;
    }

    /**
     * get appointment_phone method is stand for get the value of appointment_phone.
     *
     * @var varchar appointment_phone
     */
    public function get_appointment_phone()
    {
        return $this->_appointment_phone;
    }

    /**
     * set appointment_phone method is stand for set the value of appointment_phone.
     *
     * @var varchar appointment_phone
     */
    public function set_appointment_phone($value)
    {
        $this->_appointment_phone = $value;
    }

    /**
     * get appointment_date method is stand for get the value of appointment_date.
     *
     * @var datetime appointment_date
     */
    public function get_appointment_date()
    {
        return $this->_appointment_date;
    }

    /**
     * set appointment_date method is stand for set the value of appointment_date.
     *
     * @var datetime appointment_date
     */
    public function set_appointment_date($value)
    {
        $this->_appointment_date = $value;
    }

    /**
     * get appointment_service method is stand for get the value of
     * appointment_service.
     *
     * @var varchar appointment_service
     */
    public function get_appointment_service()
    {
        return $this->_appointment_service;
    }

    /**
     * set appointment_service method is stand for set the value of
     * appointment_service.
     *
     * @var varchar appointment_service
     */
    public function set_appointment_service($value)
    {
        $this->_appointment_service = $value;
    }

    /**
     * get appointment_subject method is stand for get the value of
     * appointment_subject.
     *
     * @var varchar appointment_subject
     */
    public function get_appointment_subject()
    {
        return $this->_appointment_subject;
    }

    /**
     * set appointment_subject method is stand for set the value of
     * appointment_subject.
     *
     * @var varchar appointment_subject
     */
    public function set_appointment_subject($value)
    {
        $this->_appointment_subject = $value;
    }

    /**
     * get appointment_message method is stand for get the value of
     * appointment_message.
     *
     * @var text appointment_message
     */
    public function get_appointment_message()
    {
        return $this->_appointment_message;
    }

    /**
     * set appointment_message method is stand for set the value of
     * appointment_message.
     *
     * @var text appointment_message
     */
    public function set_appointment_message($value)
    {
        $this->_appointment_message = $value;
    }

    /**
     * get appointment_confirm method is stand for get the value of
     * appointment_confirm.
     *
     * @var tinyint appointment_confirm
     */
    public function get_appointment_confirm()
    {
        return $this->_appointment_confirm;
    }

    /**
     * set appointment_confirm method is stand for set the value of
     * appointment_confirm.
     *
     * @var tinyint appointment_confirm
     */
    public function set_appointment_confirm($value)
    {
        $this->_appointment_confirm = $value;
    }

    /**
     * get appointment_remarks method is stand for get the value of
     * appointment_remarks.
     *
     * @var varchar appointment_remarks
     */
    public function get_appointment_remarks()
    {
        return $this->_appointment_remarks;
    }

    /**
     * set appointment_remarks method is stand for set the value of
     * appointment_remarks.
     *
     * @var varchar appointment_remarks
     */
    public function set_appointment_remarks($value)
    {
        $this->_appointment_remarks = $value;
    }

    /**
     * get appointment_status method is stand for get the value of appointment_status.
     *
     * @var varchar appointment_status
     */
    public function get_appointment_status()
    {
        return $this->_appointment_status;
    }

    /**
     * set appointment_status method is stand for set the value of appointment_status.
     *
     * @var varchar appointment_status
     */
    public function set_appointment_status($value)
    {
        $this->_appointment_status = $value;
    }

    /**
     * get appointment_created_date method is stand for get the value of
     * appointment_created_date.
     *
     * @var timestamp appointment_created_date
     */
    public function get_appointment_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_appointment_created_date));
    }

    /**
     * set appointment_created_date method is stand for set the value of
     * appointment_created_date.
     *
     * @var timestamp appointment_created_date
     */
    public function set_appointment_created_date($value)
    {
        $this->_appointment_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get appointment_updated_by method is stand for get the value of
     * appointment_updated_by.
     *
     * @var int appointment_updated_by
     */
    public function get_appointment_updated_by()
    {
        return (int) $this->_appointment_updated_by;
    }

    /**
     * set appointment_updated_by method is stand for set the value of
     * appointment_updated_by.
     *
     * @var int appointment_updated_by
     */
    public function set_appointment_updated_by($value)
    {
        $this->_appointment_updated_by = (int) $value;
    }

    /**
     * get appointment_updated_date method is stand for get the value of
     * appointment_updated_date.
     *
     * @var timestamp appointment_updated_date
     */
    public function get_appointment_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_appointment_updated_date));
    }

    /**
     * set appointment_updated_date method is stand for set the value of
     * appointment_updated_date.
     *
     * @var timestamp appointment_updated_date
     */
    public function set_appointment_updated_date($value)
    {
        $this->_appointment_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_appointment by set id thru constructor.
     *
     * @var int id
     * @var varchar appointment_name
     * @var varchar appointment_email
     * @var varchar appointment_phone
     * @var datetime appointment_date
     * @var varchar appointment_service
     * @var varchar appointment_subject
     * @var text appointment_message
     * @var tinyint appointment_confirm
     * @var varchar appointment_remarks
     * @var varchar appointment_status
     * @var timestamp appointment_created_date
     * @var int appointment_updated_by
     * @var timestamp appointment_updated_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_appointment_name($row->appointment_name);
          $this->set_appointment_email($row->appointment_email);
          $this->set_appointment_phone($row->appointment_phone);
          $this->set_appointment_date($row->appointment_date);
          $this->set_appointment_service($row->appointment_service);
          $this->set_appointment_subject($row->appointment_subject);
          $this->set_appointment_message($row->appointment_message);
          $this->set_appointment_confirm($row->appointment_confirm);
          $this->set_appointment_remarks($row->appointment_remarks);
          $this->set_appointment_status($row->appointment_status);
          $this->set_appointment_created_date($row->appointment_created_date);
          $this->set_appointment_updated_by($row->appointment_updated_by);
          $this->set_appointment_updated_date($row->appointment_updated_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar appointment_name
     * @var varchar appointment_email
     * @var varchar appointment_phone
     * @var datetime appointment_date
     * @var varchar appointment_service
     * @var varchar appointment_subject
     * @var text appointment_message
     * @var tinyint appointment_confirm
     * @var varchar appointment_remarks
     * @var varchar appointment_status
     * @var int appointment_updated_by
     */
    public function save()
    {
        $data = array(
          "appointment_name" => $this->get_appointment_name(),
          "appointment_email" => $this->get_appointment_email(),
          "appointment_phone" => $this->get_appointment_phone(),
          "appointment_date" => $this->get_appointment_date(),
          "appointment_service" => $this->get_appointment_service(),
          "appointment_subject" => $this->get_appointment_subject(),
          "appointment_message" => $this->get_appointment_message(),
          "appointment_confirm" => $this->get_appointment_confirm(),
          "appointment_remarks" => $this->get_appointment_remarks(),
          "appointment_status" => $this->get_appointment_status(),
          "appointment_updated_by" => $this->get_appointment_updated_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_appointment by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_appointment_name_by_id method is stand for get the value ofappointment_name
     * By id.
     *
     * @var varchar appointment_name
     */
    public function get_appointment_name_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_name();
    }

    /**
     * get_appointment_email_by_id method is stand for get the value
     * ofappointment_email By id.
     *
     * @var varchar appointment_email
     */
    public function get_appointment_email_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_email();
    }

    /**
     * get_appointment_phone_by_id method is stand for get the value
     * ofappointment_phone By id.
     *
     * @var varchar appointment_phone
     */
    public function get_appointment_phone_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_phone();
    }

    /**
     * get_appointment_date_by_id method is stand for get the value ofappointment_date
     * By id.
     *
     * @var datetime appointment_date
     */
    public function get_appointment_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_date();
    }

    /**
     * get_appointment_service_by_id method is stand for get the value
     * ofappointment_service By id.
     *
     * @var varchar appointment_service
     */
    public function get_appointment_service_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_service();
    }

    /**
     * get_appointment_subject_by_id method is stand for get the value
     * ofappointment_subject By id.
     *
     * @var varchar appointment_subject
     */
    public function get_appointment_subject_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_subject();
    }

    /**
     * get_appointment_message_by_id method is stand for get the value
     * ofappointment_message By id.
     *
     * @var text appointment_message
     */
    public function get_appointment_message_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_message();
    }

    /**
     * get_appointment_confirm_by_id method is stand for get the value
     * ofappointment_confirm By id.
     *
     * @var tinyint appointment_confirm
     */
    public function get_appointment_confirm_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_confirm();
    }

    /**
     * get_appointment_remarks_by_id method is stand for get the value
     * ofappointment_remarks By id.
     *
     * @var varchar appointment_remarks
     */
    public function get_appointment_remarks_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_remarks();
    }

    /**
     * get_appointment_status_by_id method is stand for get the value
     * ofappointment_status By id.
     *
     * @var varchar appointment_status
     */
    public function get_appointment_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_appointment_status();
    }

    /**
     * get_appointment_created_date_by_id method is stand for get the value
     * ofappointment_created_date By id.
     *
     * @var timestamp appointment_created_date
     */
    public function get_appointment_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_appointment_created_date()));
    }

    /**
     * get_appointment_updated_by_by_id method is stand for get the value
     * ofappointment_updated_by By id.
     *
     * @var int appointment_updated_by
     */
    public function get_appointment_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_appointment_updated_by();
    }

    /**
     * get_appointment_updated_date_by_id method is stand for get the value
     * ofappointment_updated_date By id.
     *
     * @var timestamp appointment_updated_date
     */
    public function get_appointment_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_appointment_updated_date()));
    }


}
