<?php

class Application_Model_AppointmentLogic extends Application_Model_Appointment
{
    
    public function fetchOrdered()
    {
        return $this->fetchAll($this->select()->order('id desc'));
    }
    
    public function getAppointmentsOfMonth($start, $end)
    {
        $where = $this->select()->where('appointment_status = ?', 'A')->where('appointment_date <= ?', $end)->where('appointment_date >= ?', $start);
        return $this->fetchAll($where);
    }
    
    public function fetchDataTableSelect() 
    {
        $columns = array('appointment_date', 'appointment_name', 'appointment_contact', 'appointment_service', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_AppointmentLogic(-1)), $columns);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        $enc = new Application_Model_Util_Encrypt();
        foreach($rows as $row)
        {
            $action = '';
            if(!Application_Model_RolePermissionLogic::isPermitted("Appointment:Edit")) {
                $action = '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"appointment", "action"=>"edit", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="View" class="btn btn-info" /></a> ';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("Appointment:Delete")) {
                //$action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"appointment", "action"=>"delete", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array(date('d-M-Y h:i A', strtotime($row->appointment_date)), $row->appointment_name, $row->appointment_email.' ('.$row->appointment_phone.')',  $row->appointment_service, $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
    
    
}

