<?php

class Application_Model_ClaimLogic extends Application_Model_Claim
{
    
    public function fetchOrdered()
    {
        return $this->fetchAll($this->select()->order('claim_updated_date desc'));
    }
    
    public function insertClaimData($data) {
        $claims = array();
        foreach($data as $row) {
            $obj_claim = new Application_Model_ClaimLogic(-1);
            $obj_claim->set_id($row['id']);
            $obj_claim->set_age_month($row['age_month']);
            $obj_claim->set_bo_address($row['bo_address']);
            $obj_claim->set_bo_id($row['bo_id']);
            $obj_claim->set_claim_fy($row['claim_fy']);
            $obj_claim->set_claim_insured($row['claim_insured']);
            $obj_claim->set_claim_loss_time($row['claim_loss_time']);
            $obj_claim->set_claim_loss_nature($row['claim_loss_nature']);
            $obj_claim->set_claim_loss_type($row['claim_loss_type']);
            $obj_claim->set_claim_num($row['claim_num']);
            $obj_claim->set_claim_remarks($row['claim_remarks']);
            $obj_claim->set_claim_type($row['claim_type']);
            $obj_claim->set_claim_updated_date($row['claim_updated_date']);
            $obj_claim->set_department($row['department']);
            $obj_claim->set_division_address($row['division_address']);
            $obj_claim->set_division_id(['division_id']);
            $obj_claim->set_estimated_loss($row['estimated_loss']);
            $obj_claim->set_ho_address($row['ho_address']);
            $obj_claim->set_ho_id($row['ho_id']);
            $obj_claim->set_insurance_company($row['insurance_company']);
            $obj_claim->set_insured($row['insured']);
            $obj_claim->set_material_loss($row['material_loss']);
            $obj_claim->set_policy($row['policy']);
            $obj_claim->set_policy_number($row['policy_number']);
            $obj_claim->set_region_address($row['region_address']);
            $obj_claim->set_region_id($row['region_id']);
            $obj_claim->set_status($row['status']);
            $obj_claim->set_survey_date($row['survey_date']);
            $obj_claim->set_survey_provisional($row['survey_provisional']);
            $obj_claim->set_claim_user($row['assigned_user']);
            $obj_claim->set_claim_amount_claimed($row['claim_amount_claimed']);
            $obj_claim->set_claim_amount_gross($row['claim_amount_gross']);
            $obj_claim->set_claim_amount_pay($row['claim_amount_pay']);
            $obj_claim->set_claim_reports($row['claim_reports']);
            $obj_claim->save();
            array_push($claims, $row['id']);
        }
        return $claims;
    }
    
    public function fetchOurClaims($query = null) {
        $select = null;
        $obj_user = new Application_Model_UserLogic(-1);
        $user = $obj_user->getLoggedInUser();
        if($user->get_user_type() == 'Office') {
            $select = $this->select()->where('ho_id = ?', $user->get_user_type_id())
                    ->orWhere('division_id = ?', $user->get_user_type_id())
                    ->orWhere('region_id = ?', $user->get_user_type_id())
                    ->orWhere('bo_id = ?', $user->get_user_type_id());
            if(!empty($query)) {
                $search = $this->select()->orWhere('LOWER(claim_num) like ?', '%'.strtolower($query).'%')->orWhere('LOWER(insured) like ?', '%'.strtolower($query).'%')
                        ->orWhere('LOWER(policy_number) like ?', '%'.strtolower($query).'%')->orWhere('LOWER(claim_remarks) like ?', '%'.strtolower($query).'%');
                $select->where(implode(' ', $search->getPart(Zend_Db_Select::WHERE)));
            }
        }else if($user->get_user_type() == 'Insured') {
            $select = $this->select()->where('claim_insured = ?', $user->get_user_type_id());
        }
        $select->order('claim_loss_time desc');
        return $select;
    }
    
    public function fetchClosedCount() {
        $obj_user = new Application_Model_UserLogic(-1);
        $user = $obj_user->getLoggedInUser();
        if($user->get_user_type() == 'Office') {
            $select = $this->select()->where('status like ?', 'Z%')->where('ho_id = ?', $user->get_user_type_id())
                    ->orWhere('division_id = ?', $user->get_user_type_id())
                    ->orWhere('region_id = ?', $user->get_user_type_id())
                    ->orWhere('bo_id = ?', $user->get_user_type_id());
        }else if($user->get_user_type() == 'Insured') {
            $select = $this->select()->where('status like ?', 'Z%')->where('claim_insured = ?', $user->get_user_type_id());
        }
        return $select;
    }
    
    public function getDashboardCount() {
        $total = count($this->fetchAll($this->fetchOurClaims()));
        $closed = count($this->fetchAll($this->fetchClosedCount()));
        $open = $total - $closed;
        
        return array('total'=>$total, 'open'=>$open, 'close'=>$closed);
    } 
}

