<?php

class Application_Model_ExpertLogic extends Application_Model_Expert
{
    public function fetchDataTableSelect()
    {
        $columns = array('expert_title', 'expert_short_desc', 'expert_url', 'expert_status', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_ExpertLogic(-1)), $columns);
        $where = $obj_data->get_where();
        $where->where('expert_status != ?', 'D');
        $obj_data->set_where($where);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        foreach($rows as $row)
        {
            $action = '';
            if(Application_Model_RolePermissionLogic::isPermitted("Expert:Edit")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"expert", "action"=>"edit", "id"=>$row->id)).'"><input type="button" value="Edit" class="btn btn-info" /></a>';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("Expert:Delete")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"expert", "action"=>"delete", "id"=>$row->id)).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array($row->expert_title, $row->expert_short_desc, $row->expert_url, ($row->expert_status == 'A') ? 'Active' : ($row->expert_status == 'E') ? 'Draft' : 'Block', $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
    
    public function getActiveExperts() {
        $where = $this->select()->where('expert_status = ?', 'A')->order('id');
        return $this->fetchAll($where);
    }
    
    public function countExpertUrl($url) {
        $where = $this->select()->where('expert_status = ?', 'A')->where('expert_url = ?', $url);
        return count($this->fetchAll($where));
    }
    
    public function generateExpertUrl($url) {
        $url = strtolower(preg_replace('/[^a-zA-Z0-9]/', '-', $url));
        $existRecord = $this->countExpertUrl($url);
        if($existRecord > 0) {
            return $url.'-'.$existRecord;
        }else {
            return $url;
        }
    }
    
    public function getExpertByUrl($url) {
        $where = $this->select()->where('expert_url = ?', $url)->where('expert_status = ?', 'A');
        $row = $this->fetchRow($where);
        $this->set_id($row['id']);
        $this->fetch();
    }
}

