<?php

class Application_Model_IssueLogic extends Application_Model_Issue
{
    
    public function insertIssues($data) {
        $issues = array();
        foreach($data as $row) {
            $obj_issue = new Application_Model_IssueLogic(-1);
            $obj_issue->set_id($row['id']);
            $obj_issue->set_issue_id($row['issue_id']);
            $obj_issue->set_issue_title($row['issue_title']);
            $obj_issue->set_issue_description($row['issue_description']);
            $obj_issue->set_issue_type($row['issue_type']);
            $obj_issue->set_issue_claim_id($row['issue_claim_id']);
            $obj_issue->set_issue_claim_num($row['issue_claim_num']);
            $obj_issue->set_issue_priority($row['issue_priority']);
            $obj_issue->set_issue_submit_type($row['issue_submit_type']);
            $obj_issue->set_issue_submit_by($row['issue_submit_by']);
            $obj_issue->set_issue_contact_name($row['issue_contact_name']);
            $obj_issue->set_issue_contact_email($row['issue_contact_email']);
            $obj_issue->set_issue_contact_phone($row['issue_contact_phone']);
            $obj_issue->set_issue_register_date($row['issue_register_date']);
            $obj_issue->set_issue_status($row['issue_status']);
            $obj_issue->set_issue_updated_date($row['issue_updated_date']);
            $obj_issue->save();
            array_push($issues, $row['id']);
        }
        return $issues;
    }
    
    public function fetchOurIssues() {
        $select = null;
        $obj_user = new Application_Model_UserLogic(-1);
        $user = $obj_user->getLoggedInUser();
        if($user->get_user_type() == 'Office') {
            $select = $this->select()->where('issue_submit_by = ?', $user->get_user_type_id())
                    ->where('issue_submit_type = ?', 'C')->order('id desc');
        }else if($user->get_user_type() == 'Insured') {
            $select = $this->select()->where('issue_submit_by = ?', $user->get_user_type_id())
                    ->where('issue_submit_type = ?', 'I')->order('id desc');
        }
        return $select;
    }
    
    public function fetchClosedIssues() {
        $select = null;
        $obj_user = new Application_Model_UserLogic(-1);
        $user = $obj_user->getLoggedInUser();
        if($user->get_user_type() == 'Office') {
            $select = $this->select()->where('issue_status = ?', 'Close')->where('issue_submit_by = ?', $user->get_user_type_id())
                    ->where('issue_submit_type = ?', 'C')->order('id desc');
        }else if($user->get_user_type() == 'Insured') {
            $select = $this->select()->where('issue_status = ?', 'Close')->where('issue_submit_by = ?', $user->get_user_type_id())
                    ->where('issue_submit_type = ?', 'I')->order('id desc');
        }
        return $select;
    }
    
    public function getDashboardCount() {
        $total = count($this->fetchAll($this->fetchOurIssues()));
        $closed = count($this->fetchAll($this->fetchClosedIssues()));
        $open = $total - $closed;
        
        return array('total'=>$total, 'open'=>$open, 'close'=>$closed);
    } 
}

