<?php

class Application_Model_Service extends Zend_Db_Table_Abstract
{
    
    protected $_name = 'asit_services';
    
    private $_id = null;
    
    private $_service_title = null;
    
    private $_service_image = null;
    
    private $_service_short_desc = null;
    
    private $_service_desc = null;
    
    private $_service_url = null;
    
    private $_service_meta_key = null;
    
    private $_service_meta_desc = null;
    
    private $_service_status = null;
    
    private $_service_updated_by = null;
    
    private $_service_updated_date = null;
    
    private $_service_created_by = null;
    
    private $_service_created_date = null;
    
    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
            $this->fetch();
        }
    }
    
    /**
     * get id method is stand for get the value of id.
     *
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }
    
    /**
     * set id method is stand for set the value of id.
     *
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }
    
    /**
     * get service_title method is stand for get the value of service_title.
     *
     * @var varchar service_title
     */
    public function get_service_title()
    {
        return $this->_service_title;
    }
    
    /**
     * set service_title method is stand for set the value of service_title.
     *
     * @var varchar service_title
     */
    public function set_service_title($value)
    {
        $this->_service_title = $value;
    }
    
    /**
     * get service_image method is stand for get the value of service_image.
     *
     * @var varchar service_image
     */
    public function get_service_image()
    {
        return $this->_service_image;
    }
    
    /**
     * set service_image method is stand for set the value of service_image.
     *
     * @var varchar service_image
     */
    public function set_service_image($value)
    {
        $this->_service_image = $value;
    }
    
    /**
     * get service_short_desc method is stand for get the value of service_short_desc.
     *
     * @var varchar service_short_desc
     */
    public function get_service_short_desc()
    {
        return $this->_service_short_desc;
    }
    
    /**
     * set service_short_desc method is stand for set the value of service_short_desc.
     *
     * @var varchar service_short_desc
     */
    public function set_service_short_desc($value)
    {
        $this->_service_short_desc = $value;
    }
    
    /**
     * get service_desc method is stand for get the value of service_desc.
     *
     * @var text service_desc
     */
    public function get_service_desc()
    {
        return $this->_service_desc;
    }
    
    /**
     * set service_desc method is stand for set the value of service_desc.
     *
     * @var text service_desc
     */
    public function set_service_desc($value)
    {
        $this->_service_desc = $value;
    }
    
    /**
     * get service_url method is stand for get the value of service_url.
     *
     * @var varchar service_url
     */
    public function get_service_url()
    {
        return $this->_service_url;
    }
    
    /**
     * set service_url method is stand for set the value of service_url.
     *
     * @var varchar service_url
     */
    public function set_service_url($value)
    {
        $this->_service_url = $value;
    }
    
    /**
     * get service_meta_key method is stand for get the value of service_meta_key.
     *
     * @var varchar service_meta_key
     */
    public function get_service_meta_key()
    {
        return $this->_service_meta_key;
    }
    
    /**
     * set service_meta_key method is stand for set the value of service_meta_key.
     *
     * @var varchar service_meta_key
     */
    public function set_service_meta_key($value)
    {
        $this->_service_meta_key = $value;
    }
    
    /**
     * get service_meta_desc method is stand for get the value of service_meta_desc.
     *
     * @var varchar service_meta_desc
     */
    public function get_service_meta_desc()
    {
        return $this->_service_meta_desc;
    }
    
    /**
     * set service_meta_desc method is stand for set the value of service_meta_desc.
     *
     * @var varchar service_meta_desc
     */
    public function set_service_meta_desc($value)
    {
        $this->_service_meta_desc = $value;
    }
    
    /**
     * get service_status method is stand for get the value of service_status.
     *
     * @var varchar service_status
     */
    public function get_service_status()
    {
        return $this->_service_status;
    }
    
    /**
     * set service_status method is stand for set the value of service_status.
     *
     * @var varchar service_status
     */
    public function set_service_status($value)
    {
        $this->_service_status = $value;
    }
    
    /**
     * get service_updated_by method is stand for get the value of service_updated_by.
     *
     * @var int service_updated_by
     */
    public function get_service_updated_by()
    {
        return (int) $this->_service_updated_by;
    }
    
    /**
     * set service_updated_by method is stand for set the value of service_updated_by.
     *
     * @var int service_updated_by
     */
    public function set_service_updated_by($value)
    {
        $this->_service_updated_by = (int) $value;
    }
    
    /**
     * get service_updated_date method is stand for get the value of service_updated_date.
     *
     * @var timestamp service_updated_date
     */
    public function get_service_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_service_updated_date));
    }
    
    /**
     * set service_updated_date method is stand for set the value of service_updated_date.
     *
     * @var timestamp service_updated_date
     */
    public function set_service_updated_date($value)
    {
        $this->_service_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }
    
    /**
     * get service_created_by method is stand for get the value of service_created_by.
     *
     * @var int service_created_by
     */
    public function get_service_created_by()
    {
        return (int) $this->_service_created_by;
    }
    
    /**
     * set service_created_by method is stand for set the value of service_created_by.
     *
     * @var int service_created_by
     */
    public function set_service_created_by($value)
    {
        $this->_service_created_by = (int) $value;
    }
    
    /**
     * get service_created_date method is stand for get the value of service_created_date.
     *
     * @var timestamp service_created_date
     */
    public function get_service_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_service_created_date));
    }
    
    /**
     * set service_created_date method is stand for set the value of service_created_date.
     *
     * @var timestamp service_created_date
     */
    public function set_service_created_date($value)
    {
        $this->_service_created_date = date("Y-m-d H:i:s", strtotime($value));
    }
    
    /**
     * fetch data from asit_services by set id thru constructor.
     *
     * @var int id
     * @var varchar service_title
     * @var varchar service_image
     * @var varchar service_short_desc
     * @var text service_desc
     * @var varchar service_url
     * @var varchar service_meta_key
     * @var varchar service_meta_desc
     * @var varchar service_status
     * @var int service_updated_by
     * @var timestamp service_updated_date
     * @var int service_created_by
     * @var timestamp service_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
            $this->set_id($row->id);
            $this->set_service_title($row->service_title);
            $this->set_service_image($row->service_image);
            $this->set_service_short_desc($row->service_short_desc);
            $this->set_service_desc($row->service_desc);
            $this->set_service_url($row->service_url);
            $this->set_service_meta_key($row->service_meta_key);
            $this->set_service_meta_desc($row->service_meta_desc);
            $this->set_service_status($row->service_status);
            $this->set_service_updated_by($row->service_updated_by);
            $this->set_service_updated_date($row->service_updated_date);
            $this->set_service_created_by($row->service_created_by);
            $this->set_service_created_date($row->service_created_date);
        }
    }
    
    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar service_title
     * @var varchar service_image
     * @var varchar service_short_desc
     * @var text service_desc
     * @var varchar service_url
     * @var varchar service_meta_key
     * @var varchar service_meta_desc
     * @var varchar service_status
     * @var int service_updated_by
     * @var int service_created_by
     */
    public function save()
    {
        $data = array(
            "service_title" => $this->get_service_title(),
            "service_image" => $this->get_service_image(),
            "service_short_desc" => $this->get_service_short_desc(),
            "service_desc" => $this->get_service_desc(),
            "service_url" => $this->get_service_url(),
            "service_meta_key" => $this->get_service_meta_key(),
            "service_meta_desc" => $this->get_service_meta_desc(),
            "service_status" => $this->get_service_status(),
            "service_updated_by" => $this->get_service_updated_by(),
            "service_created_by" => $this->get_service_created_by());
        if($this->get_id()==-1)
        {
            return $this->insert($data);
        }
        else
        {
            $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
            $this->update($data, $where);
        }
    }
    
    /**
     * remove method delete the record from asit_services by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }
    
    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }
    
    /**
     * get_service_title_by_id method is stand for get the value ofservice_title By id.
     *
     * @var varchar service_title
     */
    public function get_service_title_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_title();
    }
    
    /**
     * get_service_image_by_id method is stand for get the value ofservice_image By id.
     *
     * @var varchar service_image
     */
    public function get_service_image_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_image();
    }
    
    /**
     * get_service_short_desc_by_id method is stand for get the value ofservice_short_desc By
     * id.
     *
     * @var varchar service_short_desc
     */
    public function get_service_short_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_short_desc();
    }
    
    /**
     * get_service_desc_by_id method is stand for get the value ofservice_desc By id.
     *
     * @var text service_desc
     */
    public function get_service_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_desc();
    }
    
    /**
     * get_service_url_by_id method is stand for get the value ofservice_url By id.
     *
     * @var varchar service_url
     */
    public function get_service_url_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_url();
    }
    
    /**
     * get_service_meta_key_by_id method is stand for get the value ofservice_meta_key By id.
     *
     * @var varchar service_meta_key
     */
    public function get_service_meta_key_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_meta_key();
    }
    
    /**
     * get_service_meta_desc_by_id method is stand for get the value ofservice_meta_desc By
     * id.
     *
     * @var varchar service_meta_desc
     */
    public function get_service_meta_desc_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_meta_desc();
    }
    
    /**
     * get_service_status_by_id method is stand for get the value ofservice_status By id.
     *
     * @var varchar service_status
     */
    public function get_service_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_service_status();
    }
    
    /**
     * get_service_updated_by_by_id method is stand for get the value ofservice_updated_by By
     * id.
     *
     * @var int service_updated_by
     */
    public function get_service_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_service_updated_by();
    }
    
    /**
     * get_service_updated_date_by_id method is stand for get the value
     * ofservice_updated_date By id.
     *
     * @var timestamp service_updated_date
     */
    public function get_service_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_service_updated_date()));
    }
    
    /**
     * get_service_created_by_by_id method is stand for get the value ofservice_created_by By
     * id.
     *
     * @var int service_created_by
     */
    public function get_service_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_service_created_by();
    }
    
    /**
     * get_service_created_date_by_id method is stand for get the value
     * ofservice_created_date By id.
     *
     * @var timestamp service_created_date
     */
    public function get_service_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_service_created_date()));
    }
    
    
}
