<?php

class Application_Model_ServiceLogic extends Application_Model_Service
{
    public function fetchDataTableSelect()
    {
        $columns = array('service_title', 'service_short_desc', 'service_url', 'service_status', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_ServiceLogic(-1)), $columns);
        $where = $obj_data->get_where();
        $where->where('service_status != ?', 'D');
        $obj_data->set_where($where);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        foreach($rows as $row)
        {
            $action = '';
            if(Application_Model_RolePermissionLogic::isPermitted("Service:Edit")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"service", "action"=>"edit", "id"=>$row->id)).'"><input type="button" value="Edit" class="btn btn-info" /></a>';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("Service:Delete")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"service", "action"=>"delete", "id"=>$row->id)).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array($row->service_title, $row->service_short_desc, $row->service_url, ($row->service_status == 'A') ? 'Active' : (($row->service_status == 'E') ? 'Draft' : 'Block'), $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
    
    public function getActiveServices() {
        $where = $this->select()->where('service_status = ?', 'A')->order('id');
        return $this->fetchAll($where);
    }
    
    public function countServiceUrl($url) {
        $where = $this->select()->where('service_status = ?', 'A')->where('service_url = ?', $url);
        return count($this->fetchAll($where));
    }
    
    public function generateServiceUrl($url) {
        $url = strtolower(preg_replace('/[^a-zA-Z0-9]/', '-', $url));
        $existRecord = $this->countServiceUrl($url);
        if($existRecord > 0) {
            return $url.'-'.$existRecord;
        }else {
            return $url;
        }
    }
    
    public function getServiceByUrl($url) {
        $where = $this->select()->where('service_url = ?', $url)->where('service_status = ?', 'A');
        $row = $this->fetchRow($where);
        $this->set_id($row['id']);
        $this->fetch();
    }
}

