<?php

class Application_Model_Team extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_team';

    private $_id = null;

    private $_team_name = null;
    
    private $_team_designation = null;
    
    private $_team_pic = null;
    
    private $_team_about = null;
    
    private $_team_fb = null;
    
    private $_team_tweet = null;
    
    private $_team_skype = null;
    
    private $_team_linkedin = null;
    
    private $_team_order = null;

    private $_team_status = null;

    private $_team_updated_by = null;

    private $_team_updated_date = null;

    private $_team_created_by = null;

    private $_team_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     *
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    function get_id() {
        return $this->_id;
    }

    function get_team_name() {
        return $this->_team_name;
    }

    function get_team_designation() {
        return $this->_team_designation;
    }

    function get_team_pic() {
        return $this->_team_pic;
    }

    function get_team_about() {
        return $this->_team_about;
    }

    function get_team_fb() {
        return $this->_team_fb;
    }

    function get_team_tweet() {
        return $this->_team_tweet;
    }

    function get_team_skype() {
        return $this->_team_skype;
    }

    function get_team_linkedin() {
        return $this->_team_linkedin;
    }

    function get_team_order() {
        return $this->_team_order;
    }

    function get_team_status() {
        return $this->_team_status;
    }

    function get_team_updated_by() {
        return $this->_team_updated_by;
    }

    function get_team_updated_date() {
        return $this->_team_updated_date;
    }

    function get_team_created_by() {
        return $this->_team_created_by;
    }

    function get_team_created_date() {
        return $this->_team_created_date;
    }

    function set_id($id) {
        $this->_id = $id;
    }

    function set_team_name($team_name) {
        $this->_team_name = $team_name;
    }

    function set_team_designation($team_designation) {
        $this->_team_designation = $team_designation;
    }

    function set_team_pic($team_pic) {
        $this->_team_pic = $team_pic;
    }

    function set_team_about($team_about) {
        $this->_team_about = $team_about;
    }

    function set_team_fb($team_fb) {
        $this->_team_fb = $team_fb;
    }

    function set_team_tweet($team_tweet) {
        $this->_team_tweet = $team_tweet;
    }

    function set_team_skype($team_skype) {
        $this->_team_skype = $team_skype;
    }

    function set_team_linkedin($team_linkedin) {
        $this->_team_linkedin = $team_linkedin;
    }

    function set_team_order($team_order) {
        $this->_team_order = $team_order;
    }

    function set_team_status($team_status) {
        $this->_team_status = $team_status;
    }

    function set_team_updated_by($team_updated_by) {
        $this->_team_updated_by = $team_updated_by;
    }

    function set_team_updated_date($team_updated_date) {
        $this->_team_updated_date = $team_updated_date;
    }

    function set_team_created_by($team_created_by) {
        $this->_team_created_by = $team_created_by;
    }

    function set_team_created_date($team_created_date) {
        $this->_team_created_date = $team_created_date;
    }

    
    /**
     * fetch data from asit_intro_teams by set id thru constructor.
     *
     * @var int id
     * @var varchar team_title
     * @var varchar team_status
     * @var int team_updated_by
     * @var timestamp team_updated_date
     * @var int team_created_by
     * @var timestamp team_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_team_name($row->team_name);
          $this->set_team_designation($row->team_designation);
          $this->set_team_pic($row->team_pic);
          $this->set_team_about($row->team_about);
          $this->set_team_fb($row->team_fb);
          $this->set_team_tweet($row->team_tweet);
          $this->set_team_skype($row->team_skype);
          $this->set_team_linkedin($row->team_linkedin);
          $this->set_team_order($row->team_order);
          $this->set_team_status($row->team_status);
          $this->set_team_updated_by($row->team_updated_by);
          $this->set_team_updated_date($row->team_updated_date);
          $this->set_team_created_by($row->team_created_by);
          $this->set_team_created_date($row->team_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     *
     * @var varchar team_title
     * @var varchar team_status
     * @var int team_updated_by
     * @var int team_created_by
     */
    public function save()
    {
        $data = array(
            "team_name" => $this->get_team_name(),
            "team_designation" => $this->get_team_designation(),
            "team_pic" => $this->get_team_pic(),
            "team_about" => $this->get_team_about(),
            "team_fb" => $this->get_team_fb(),
            "team_tweet" => $this->get_team_tweet(),
            "team_skype" => $this->get_team_skype(),
            "team_linkedin" => $this->get_team_linkedin(),
            "team_order" => $this->get_team_order(),
            "team_status" => $this->get_team_status(),
            "team_updated_by" => $this->get_team_updated_by(),
            "team_created_by" => $this->get_team_created_by());
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_intro_teams by id.
     *
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_team_title_by_id method is stand for get the value ofteam_title By id.
     *
     * @var varchar team_title
     */
    public function get_team_name_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_team_name();
    }

    /**
     * get_team_status_by_id method is stand for get the value ofteam_status By id.
     *
     * @var varchar team_status
     */
    public function get_team_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_team_status();
    }

    /**
     * get_team_updated_by_by_id method is stand for get the value ofteam_updated_by By
     * id.
     *
     * @var int team_updated_by
     */
    public function get_team_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_team_updated_by();
    }

    /**
     * get_team_updated_date_by_id method is stand for get the value ofteam_updated_date
     * By id.
     *
     * @var timestamp team_updated_date
     */
    public function get_team_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_team_updated_date()));
    }

    /**
     * get_team_created_by_by_id method is stand for get the value ofteam_created_by By
     * id.
     *
     * @var int team_created_by
     */
    public function get_team_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_team_created_by();
    }

    /**
     * get_team_created_date_by_id method is stand for get the value ofteam_created_date
     * By id.
     *
     * @var timestamp team_created_date
     */
    public function get_team_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_team_created_date()));
    }


}
