<?php

class Application_Model_TeamLogic extends Application_Model_Team
{
    
    public function fetchOrdered()
    {
        return $this->fetchAll($this->select()->where('team_status = ?', 'A')->order('team_order'));
    }
    
    public function fetchDataTableSelect() 
    {
        $columns = array('team_name', 'team_designation', 'team_order', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_TeamLogic(-1)), $columns);
        $where = $obj_data->get_where();
        $where->where('team_status = ?', 'A');
        $obj_data->set_where($where);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        $enc = new Application_Model_Util_Encrypt();
        foreach($rows as $row)
        {
            $action = '';
            if(Application_Model_RolePermissionLogic::isPermitted("Team:Edit")) {
                $action = '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"team", "action"=>"edit", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Edit" class="btn btn-info" /></a> ';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("Team:Delete")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"team", "action"=>"delete", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array($row->team_name, $row->team_designation, $row->team_order, $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
}

