<?php

class Application_Model_Testimonial extends Zend_Db_Table_Abstract
{

    protected $_name = 'asit_testimonial';

    private $_id = null;

    private $_testimonial_name = null;

    private $_testimonial_company = null;

    private $_testimonial_pic = null;

    private $_testimonial_content = null;

    private $_testimonial_stars = null;

    private $_testimonial_status = null;

    private $_testimonial_updated_by = null;

    private $_testimonial_updated_date = null;

    private $_testimonial_created_by = null;

    private $_testimonial_created_date = null;

    /**
     * Constructor initialize primary key field value to set the set_id method. If
     * value = -1 then default object loaded.
     * 
     * @var int id
     */
    public function __construct($id)
    {
        parent::__construct();
        $id = (int) $id;
        $this->set_id($id);
        if($id!=-1)
        {
          $this->fetch();
        }
    }

    /**
     * get id method is stand for get the value of id.
     * 
     * @var int id
     */
    public function get_id()
    {
        return (int) $this->_id;
    }

    /**
     * set id method is stand for set the value of id.
     * 
     * @var int id
     */
    public function set_id($value)
    {
        $this->_id = (int) $value;
    }

    /**
     * get testimonial_name method is stand for get the value of testimonial_name.
     * 
     * @var varchar testimonial_name
     */
    public function get_testimonial_name()
    {
        return $this->_testimonial_name;
    }

    /**
     * set testimonial_name method is stand for set the value of testimonial_name.
     * 
     * @var varchar testimonial_name
     */
    public function set_testimonial_name($value)
    {
        $this->_testimonial_name = $value;
    }

    /**
     * get testimonial_company method is stand for get the value of
     * testimonial_company.
     * 
     * @var varchar testimonial_company
     */
    public function get_testimonial_company()
    {
        return $this->_testimonial_company;
    }

    /**
     * set testimonial_company method is stand for set the value of
     * testimonial_company.
     * 
     * @var varchar testimonial_company
     */
    public function set_testimonial_company($value)
    {
        $this->_testimonial_company = $value;
    }

    /**
     * get testimonial_pic method is stand for get the value of testimonial_pic.
     * 
     * @var varchar testimonial_pic
     */
    public function get_testimonial_pic()
    {
        return $this->_testimonial_pic;
    }

    /**
     * set testimonial_pic method is stand for set the value of testimonial_pic.
     * 
     * @var varchar testimonial_pic
     */
    public function set_testimonial_pic($value)
    {
        $this->_testimonial_pic = $value;
    }

    /**
     * get testimonial_content method is stand for get the value of
     * testimonial_content.
     * 
     * @var varchar testimonial_content
     */
    public function get_testimonial_content()
    {
        return $this->_testimonial_content;
    }

    /**
     * set testimonial_content method is stand for set the value of
     * testimonial_content.
     * 
     * @var varchar testimonial_content
     */
    public function set_testimonial_content($value)
    {
        $this->_testimonial_content = $value;
    }

    /**
     * get testimonial_stars method is stand for get the value of testimonial_stars.
     * 
     * @var tinyint testimonial_stars
     */
    public function get_testimonial_stars()
    {
        return $this->_testimonial_stars;
    }

    /**
     * set testimonial_stars method is stand for set the value of testimonial_stars.
     * 
     * @var tinyint testimonial_stars
     */
    public function set_testimonial_stars($value)
    {
        $this->_testimonial_stars = $value;
    }

    /**
     * get testimonial_status method is stand for get the value of testimonial_status.
     * 
     * @var varchar testimonial_status
     */
    public function get_testimonial_status()
    {
        return $this->_testimonial_status;
    }

    /**
     * set testimonial_status method is stand for set the value of testimonial_status.
     * 
     * @var varchar testimonial_status
     */
    public function set_testimonial_status($value)
    {
        $this->_testimonial_status = $value;
    }

    /**
     * get testimonial_updated_by method is stand for get the value of
     * testimonial_updated_by.
     * 
     * @var int testimonial_updated_by
     */
    public function get_testimonial_updated_by()
    {
        return (int) $this->_testimonial_updated_by;
    }

    /**
     * set testimonial_updated_by method is stand for set the value of
     * testimonial_updated_by.
     * 
     * @var int testimonial_updated_by
     */
    public function set_testimonial_updated_by($value)
    {
        $this->_testimonial_updated_by = (int) $value;
    }

    /**
     * get testimonial_updated_date method is stand for get the value of
     * testimonial_updated_date.
     * 
     * @var timestamp testimonial_updated_date
     */
    public function get_testimonial_updated_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_testimonial_updated_date));
    }

    /**
     * set testimonial_updated_date method is stand for set the value of
     * testimonial_updated_date.
     * 
     * @var timestamp testimonial_updated_date
     */
    public function set_testimonial_updated_date($value)
    {
        $this->_testimonial_updated_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * get testimonial_created_by method is stand for get the value of
     * testimonial_created_by.
     * 
     * @var int testimonial_created_by
     */
    public function get_testimonial_created_by()
    {
        return (int) $this->_testimonial_created_by;
    }

    /**
     * set testimonial_created_by method is stand for set the value of
     * testimonial_created_by.
     * 
     * @var int testimonial_created_by
     */
    public function set_testimonial_created_by($value)
    {
        $this->_testimonial_created_by = (int) $value;
    }

    /**
     * get testimonial_created_date method is stand for get the value of
     * testimonial_created_date.
     * 
     * @var timestamp testimonial_created_date
     */
    public function get_testimonial_created_date()
    {
        return date("d-M-Y (H:i:s)", strtotime($this->_testimonial_created_date));
    }

    /**
     * set testimonial_created_date method is stand for set the value of
     * testimonial_created_date.
     * 
     * @var timestamp testimonial_created_date
     */
    public function set_testimonial_created_date($value)
    {
        $this->_testimonial_created_date = date("Y-m-d H:i:s", strtotime($value));
    }

    /**
     * fetch data from asit_testimonial by set id thru constructor.
     * 
     * @var int id
     * @var varchar testimonial_name
     * @var varchar testimonial_company
     * @var varchar testimonial_pic
     * @var varchar testimonial_content
     * @var tinyint testimonial_stars
     * @var varchar testimonial_status
     * @var int testimonial_updated_by
     * @var timestamp testimonial_updated_date
     * @var int testimonial_created_by
     * @var timestamp testimonial_created_date
     */
    public function fetch()
    {
        $select=$this->select()->where("id = ?",$this->get_id());
        $row=$this->fetchRow($select);
        if($row!=null){
          $this->set_id($row->id);
          $this->set_testimonial_name($row->testimonial_name);
          $this->set_testimonial_company($row->testimonial_company);
          $this->set_testimonial_pic($row->testimonial_pic);
          $this->set_testimonial_content($row->testimonial_content);
          $this->set_testimonial_stars($row->testimonial_stars);
          $this->set_testimonial_status($row->testimonial_status);
          $this->set_testimonial_updated_by($row->testimonial_updated_by);
          $this->set_testimonial_updated_date($row->testimonial_updated_date);
          $this->set_testimonial_created_by($row->testimonial_created_by);
          $this->set_testimonial_created_date($row->testimonial_created_date);
        }
    }

    /**
     * save method is stand for saving the data, if id = -1 then data insert as a new
     * record and if id is set via constructor then data should update
     * 
     * @var int id
     * @var varchar testimonial_name
     * @var varchar testimonial_company
     * @var varchar testimonial_pic
     * @var varchar testimonial_content
     * @var tinyint testimonial_stars
     * @var varchar testimonial_status
     * @var int testimonial_updated_by
     * @var timestamp testimonial_updated_date
     * @var int testimonial_created_by
     * @var timestamp testimonial_created_date
     */
    public function save()
    {
		
        $data = array(
          "testimonial_name" => $this->get_testimonial_name(),
          "testimonial_company" => $this->get_testimonial_company(),
          "testimonial_pic" => $this->get_testimonial_pic(),
          "testimonial_content" => $this->get_testimonial_content(),
          "testimonial_stars" => $this->get_testimonial_stars(),
          "testimonial_status" => $this->get_testimonial_status(),
          "testimonial_updated_by" => $this->get_testimonial_updated_by(),
          "testimonial_updated_date" => $this->get_testimonial_updated_date(),
          "testimonial_created_by" => $this->get_testimonial_created_by(),
          "testimonial_created_date" => $this->get_testimonial_created_date());
		  //Zend_Debug::dump($data);
        if($this->get_id()==-1)
        {
          return $this->insert($data);
        }
        else
        {
          $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
          $this->update($data, $where);
        }
    }

    /**
     * remove method delete the record from asit_testimonial by id.
     * 
     * @var int id
     */
    public function remove()
    {
        $where = $this->getAdapter()->quoteInto("id = ?", $this->get_id());
        $this->delete($where);
    }

    /**
     * fetch_list_select stand for selecting all records.
     */
    public function fetch_list_select()
    {
        $select = $this->select();
        return $select;
    }

    /**
     * get_testimonial_name_by_id method is stand for get the value oftestimonial_name
     * By id.
     * 
     * @var varchar testimonial_name
     */
    public function get_testimonial_name_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_name();
    }

    /**
     * get_testimonial_company_by_id method is stand for get the value
     * oftestimonial_company By id.
     * 
     * @var varchar testimonial_company
     */
    public function get_testimonial_company_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_company();
    }

    /**
     * get_testimonial_pic_by_id method is stand for get the value oftestimonial_pic By
     * id.
     * 
     * @var varchar testimonial_pic
     */
    public function get_testimonial_pic_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_pic();
    }

    /**
     * get_testimonial_content_by_id method is stand for get the value
     * oftestimonial_content By id.
     * 
     * @var varchar testimonial_content
     */
    public function get_testimonial_content_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_content();
    }

    /**
     * get_testimonial_stars_by_id method is stand for get the value
     * oftestimonial_stars By id.
     * 
     * @var tinyint testimonial_stars
     */
    public function get_testimonial_stars_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_stars();
    }

    /**
     * get_testimonial_status_by_id method is stand for get the value
     * oftestimonial_status By id.
     * 
     * @var varchar testimonial_status
     */
    public function get_testimonial_status_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return $this->get_testimonial_status();
    }

    /**
     * get_testimonial_updated_by_by_id method is stand for get the value
     * oftestimonial_updated_by By id.
     * 
     * @var int testimonial_updated_by
     */
    public function get_testimonial_updated_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_testimonial_updated_by();
    }

    /**
     * get_testimonial_updated_date_by_id method is stand for get the value
     * oftestimonial_updated_date By id.
     * 
     * @var timestamp testimonial_updated_date
     */
    public function get_testimonial_updated_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_testimonial_updated_date()));
    }

    /**
     * get_testimonial_created_by_by_id method is stand for get the value
     * oftestimonial_created_by By id.
     * 
     * @var int testimonial_created_by
     */
    public function get_testimonial_created_by_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return (int) $this->get_testimonial_created_by();
    }

    /**
     * get_testimonial_created_date_by_id method is stand for get the value
     * oftestimonial_created_date By id.
     * 
     * @var timestamp testimonial_created_date
     */
    public function get_testimonial_created_date_by_id($id)
    {
        $this->set_id($id);
        $this->fetch();
        return date("d-M-Y (H:i:s)", strtotime($this->get_testimonial_created_date()));
    }


}
