<?php

class Application_Model_TestimonialLogic extends Application_Model_Testimonial
{
    
    public function fetchOrdered()
    {
        return $this->fetchAll($this->select()->where('testimonial_status = ?', 'A')->order('testimonial_name'));
    }
    
    public function fetchDataTableSelect() 
    {
        $columns = array('testimonial_name', 'testimonial_company', 'testimonial_content', 'testimonial_stars', 'action');
        $obj_data = new Application_Model_Util_Datatable((new Application_Model_TestimonialLogic(-1)), $columns);
        $where = $obj_data->get_where();
        $where->where('testimonial_status = ?', 'A');
        $obj_data->set_where($where);
        $rows = $obj_data->fetch();
        $results = array();
        $i = 0;
        $url = new Zend_View_Helper_Url();
        $enc = new Application_Model_Util_Encrypt();
        foreach($rows as $row)
        {
            $action = '';
            if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Edit")) {
                $action = '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"testimonial", "action"=>"edit", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Edit" class="btn btn-info" /></a> ';
            }
            if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Delete")) {
                $action .= '<a href="'.$url->url(array("module"=>"dynasty", "controller"=>"testimonial", "action"=>"delete", "id"=>$enc->hideContent($row->id))).'"><input type="button" value="Delete" class="btn btn-danger" /></a>';
            }
            $results[$i] = array($row->testimonial_name, $row->testimonial_company, $row->testimonial_content, $action);
            $i += 1;
        }
        return $obj_data->configureOutput($results);
    }
}

