<?php

class Dynasty_AppointmentController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(!Application_Model_RolePermissionLogic::isPermitted("Appointment:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_appoint = new Application_Model_AppointmentLogic(-1);
        echo $obj_appoint->fetchDataTableSelect();
    }

    public function editAction()
    {
        if(!Application_Model_RolePermissionLogic::isPermitted("Appointment:Edit")) {
            $encId = $this->_getParam("id");
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($encId);
            $obj_form = new Application_Form_Appointment();
            $this->view->appointment = $obj_appoint = new Application_Model_AppointmentLogic($id);
            $obj_form->id->setValue($encId);
            $obj_form->appointment_confirm->setValue($obj_appoint->get_appointment_confirm());
            $obj_form->appointment_remarks->setValue($obj_appoint->get_appointment_remarks());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_appoint->set_appointment_confirm($obj_form->appointment_confirm->getValue());
                    $obj_appoint->set_appointment_remarks($obj_form->appointment_remarks->getValue());
                    $obj_appoint->set_appointment_status(($obj_form->appointment_confirm->getValue() == 'Confirmed') ? 'A' : 'REJECT');
                    $obj_appoint->save();

                    $msub = ($obj_form->appointment_confirm->getValue() == 'Confirmed') ? 'Appointment Confirmation from M Goswami & Associates' : 'Appointment Rejection from M Goswami & Associates';
                    $mbody = '<p>Dear '.$obj_appoint->get_appointment_name().', </p><br /><p>Your appointment has been confirmed with M Goswami & Associates, Please check the enclosed appointment details:</p><br /><table borde="0"><tr><td><b>Appointment Date:</b></td><td>'.$obj_appoint->get_appointment_date().'</td></tr><tr><td><b>Remarks:</b></td><td>'.$obj_appoint->get_appointment_remarks().'</td></tr></table><br /><br /><p>We are waiting for your presence.</p><br /><p>Thank You<br />--<br />Warm Regards,<br />Support Team<br />M Goswami & Associates</p>';

                    $obj_mail = new Application_Model_Email_Util();
                    $obj_mail->send($obj_appoint->get_appointment_email(), $msub, $mbody);

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Appointment Status Updated Successfully!!!";
                    $this->_redirect("dynasty/appointment/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

}

