<?php

class Dynasty_ExpertController extends Zend_Controller_Action
{
    
    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }
    
    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Expert:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_expert = new Application_Model_ExpertLogic(-1);
        echo $obj_expert->fetchDataTableSelect();
    }
    
    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Expert:Add")) {
            $obj_form = new Application_Form_Expert();
            $this->view->form = $obj_form;
            $obj_asitexpert = new Application_Model_ExpertLogic(-1);
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitexpert->set_expert_title($obj_form->expert_title->getValue());
                    $obj_asitexpert->set_expert_image($obj_form->expert_image->getValue());
                    $obj_asitexpert->set_expert_short_desc($obj_form->expert_short_desc->getValue());
                    $obj_asitexpert->set_expert_desc($obj_form->expert_desc->getValue());
                    $obj_asitexpert->set_expert_url($obj_asitexpert->generateExpertUrl($obj_form->expert_title->getValue()));
                    $obj_asitexpert->set_expert_meta_key($obj_form->expert_meta_key->getValue());
                    $obj_asitexpert->set_expert_meta_desc($obj_form->expert_meta_desc->getValue());
                    $obj_asitexpert->set_expert_status($obj_form->expert_status->getValue());
                    $obj_asitexpert->set_expert_updated_by($user->getLoggedInUserId());
                    $obj_asitexpert->set_expert_created_by($user->getLoggedInUserId());
                    $obj_asitexpert->save();
                    
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Expert Created Successfully!!!";
                    $this->_redirect("dynasty/expert/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Expert:Edit")) {
            $id = $this->_getParam("id");
            $obj_form = new Application_Form_Expert();
            $obj_asitexpert = new Application_Model_Expert($id);
            $obj_form->expert_title->setValue($obj_asitexpert->get_expert_title());
            $obj_form->expert_image->setRequired(false);
            $obj_form->expert_short_desc->setValue($obj_asitexpert->get_expert_short_desc());
            $obj_form->expert_desc->setValue($obj_asitexpert->get_expert_desc());
            $obj_form->expert_meta_key->setValue($obj_asitexpert->get_expert_meta_key());
            $obj_form->expert_meta_desc->setValue($obj_asitexpert->get_expert_meta_desc());
            $obj_form->expert_status->setValue($obj_asitexpert->get_expert_status());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitexpert->set_expert_title($obj_form->expert_title->getValue());
                    if(count(explode('.', $obj_form->expert_image->getValue())) > 1) {
                        $obj_asitexpert->set_expert_image($obj_form->expert_image->getValue());
                    }
                    $obj_asitexpert->set_expert_short_desc($obj_form->expert_short_desc->getValue());
                    $obj_asitexpert->set_expert_desc($obj_form->expert_desc->getValue());
                    $obj_asitexpert->set_expert_meta_key($obj_form->expert_meta_key->getValue());
                    $obj_asitexpert->set_expert_meta_desc($obj_form->expert_meta_desc->getValue());
                    $obj_asitexpert->set_expert_status($obj_form->expert_status->getValue());
                    $obj_asitexpert->set_expert_updated_by($user->getLoggedInUserId());
                    $obj_asitexpert->save();
                    
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Expert Updated Successfully!!!";
                    $this->_redirect("dynasty/expert/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Expert:Delete")) {
            $id = $this->_getParam("id");
            $obj_asitexpert = new Application_Model_ExpertLogic($id);
            $obj_asitexpert->set_expert_status('D');
            $obj_asitexpert->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Expert Removed Successfully!!!";
            $this->_redirect("dynasty/expert/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    
}
