<?php

class Dynasty_ProductController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Role:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_prod = new Application_Model_ProductLogic(-1);
        echo $obj_prod->fetchDataTableSelect();
    }

    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Role:Add")) {
            $obj_form = new Application_Form_Product();
            $this->view->form = $obj_form;
            $obj_asitproducts = new Application_Model_ProductLogic(-1);
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitproducts->set_product_name($obj_form->product_name->getValue());
                    $obj_asitproducts->set_product_tag_line($obj_form->product_tag_line->getValue());
                    $obj_asitproducts->set_product_img($obj_form->product_img->getValue());
                    $obj_asitproducts->set_product_category($obj_form->product_category->getValue());
                    $obj_asitproducts->set_product_type($obj_form->product_type->getValue());
                    $obj_asitproducts->set_product_qty($obj_form->product_qty->getValue());
                    $obj_asitproducts->set_product_desc($obj_form->product_desc->getValue());
                    $obj_asitproducts->set_product_uses($obj_form->product_uses->getValue());
                    $obj_asitproducts->set_product_action($obj_form->product_action->getValue());
                    $obj_asitproducts->set_product_precaution($obj_form->product_precaution->getValue());
                    $obj_asitproducts->set_product_side_effect($obj_form->product_side_effect->getValue());
                    $obj_asitproducts->set_product_meta_key($obj_form->product_meta_key->getValue());
                    $obj_asitproducts->set_product_meta_desc($obj_form->product_meta_desc->getValue());
                    $url = $obj_asitproducts->generateProductUrl($obj_form->product_name->getValue());
                    $obj_asitproducts->set_product_url($url);
                    $obj_asitproducts->set_product_status('A');
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitproducts->set_product_updated_by($user->getLoggedInUserId());
                    $obj_asitproducts->set_product_created_by($user->getLoggedInUserId());
                    $obj_asitproducts->save();

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Product Created Successfully!!!";
                    $this->_redirect("dynasty/product/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Role:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam("id"));
            $obj_form = new Application_Form_Product();
            $obj_asitproducts = new Application_Model_Product($id);
            $obj_form->product_name->setValue($obj_asitproducts->get_product_name());
            $obj_form->product_tag_line->setValue($obj_asitproducts->get_product_tag_line());
            $obj_form->product_category->setValue($obj_asitproducts->get_product_category());
            $obj_form->product_type->setValue($obj_asitproducts->get_product_type());
            $obj_form->product_qty->setValue($obj_asitproducts->get_product_qty());
            $obj_form->product_desc->setValue($obj_asitproducts->get_product_desc());
            $obj_form->product_uses->setValue($obj_asitproducts->get_product_uses());
            $obj_form->product_action->setValue($obj_asitproducts->get_product_action());
            $obj_form->product_precaution->setValue($obj_asitproducts->get_product_precaution());
            $obj_form->product_side_effect->setValue($obj_asitproducts->get_product_side_effect());
            $obj_form->product_meta_key->setValue($obj_asitproducts->get_product_meta_key());
            $obj_form->product_meta_desc->setValue($obj_asitproducts->get_product_meta_desc());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $obj_asitproducts->set_product_name($obj_form->product_name->getValue());
                    $obj_asitproducts->set_product_tag_line($obj_form->product_tag_line->getValue());
                    if(count(explode('.', $obj_form->product_img->getValue())) > 1) {
                        $obj_asitproducts->set_product_img($obj_form->product_img->getValue());
                    }
                    $obj_asitproducts->set_product_category($obj_form->product_category->getValue());
                    $obj_asitproducts->set_product_type($obj_form->product_type->getValue());
                    $obj_asitproducts->set_product_qty($obj_form->product_qty->getValue());
                    $obj_asitproducts->set_product_desc($obj_form->product_desc->getValue());
                    $obj_asitproducts->set_product_uses($obj_form->product_uses->getValue());
                    $obj_asitproducts->set_product_action($obj_form->product_action->getValue());
                    $obj_asitproducts->set_product_precaution($obj_form->product_precaution->getValue());
                    $obj_asitproducts->set_product_side_effect($obj_form->product_side_effect->getValue());
                    $obj_asitproducts->set_product_meta_key($obj_form->product_meta_key->getValue());
                    $obj_asitproducts->set_product_meta_desc($obj_form->product_meta_desc->getValue());
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitproducts->set_product_updated_by($user->getLoggedInUserId());
                    $obj_asitproducts->save();

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Product Updated Successfully!!!";
                    $this->_redirect("dynasty/product/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Role:Delete")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam('id'));
            $obj_product = new Application_Model_Product($id);
            $obj_product->set_product_status('D');
            $obj_product->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Product Removed Successfully!!!";
            $this->_redirect("dynasty/product/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }


}

