<?php

class Dynasty_ServiceController extends Zend_Controller_Action
{
    
    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }
    
    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Service:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_service = new Application_Model_ServiceLogic(-1);
        echo $obj_service->fetchDataTableSelect();
    }
    
    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Service:Add")) {
            $obj_form = new Application_Form_Service();
            $this->view->form = $obj_form;
            $obj_asitservice = new Application_Model_ServiceLogic(-1);
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitservice->set_service_title($obj_form->service_title->getValue());
                    $obj_asitservice->set_service_image($obj_form->service_image->getValue());
                    $obj_asitservice->set_service_short_desc($obj_form->service_short_desc->getValue());
                    $obj_asitservice->set_service_desc($obj_form->service_desc->getValue());
                    $obj_asitservice->set_service_url($obj_asitservice->generateServiceUrl($obj_form->service_title->getValue()));
                    $obj_asitservice->set_service_meta_key($obj_form->service_meta_key->getValue());
                    $obj_asitservice->set_service_meta_desc($obj_form->service_meta_desc->getValue());
                    $obj_asitservice->set_service_status($obj_form->service_status->getValue());
                    $obj_asitservice->set_service_updated_by($user->getLoggedInUserId());
                    $obj_asitservice->set_service_created_by($user->getLoggedInUserId());
                    $obj_asitservice->save();
                    
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Service Created Successfully!!!";
                    $this->_redirect("dynasty/service/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Service:Edit")) {
            $id = $this->_getParam("id");
            $obj_form = new Application_Form_Service();
            $obj_asitservice = new Application_Model_Service($id);
            $obj_form->service_title->setValue($obj_asitservice->get_service_title());
            $obj_form->service_image->setRequired(false);
            $obj_form->service_short_desc->setValue($obj_asitservice->get_service_short_desc());
            $obj_form->service_desc->setValue($obj_asitservice->get_service_desc());
            $obj_form->service_meta_key->setValue($obj_asitservice->get_service_meta_key());
            $obj_form->service_meta_desc->setValue($obj_asitservice->get_service_meta_desc());
            $obj_form->service_status->setValue($obj_asitservice->get_service_status());
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
                $data=$this->getRequest()->getPost();
                if($obj_form->isValid($data)){
                    $user = new Application_Model_UserLogic(-1);
                    $obj_asitservice->set_service_title($obj_form->service_title->getValue());
                    if(count(explode('.', $obj_form->service_image->getValue())) > 1) {
                        $obj_asitservice->set_service_image($obj_form->service_image->getValue());
                    }
                    $obj_asitservice->set_service_short_desc($obj_form->service_short_desc->getValue());
                    $obj_asitservice->set_service_desc($obj_form->service_desc->getValue());
                    $obj_asitservice->set_service_meta_key($obj_form->service_meta_key->getValue());
                    $obj_asitservice->set_service_meta_desc($obj_form->service_meta_desc->getValue());
                    $obj_asitservice->set_service_status($obj_form->service_status->getValue());
                    $obj_asitservice->set_service_updated_by($user->getLoggedInUserId());
                    $obj_asitservice->save();
                    
                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Service Updated Successfully!!!";
                    $this->_redirect("dynasty/service/index");
                }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Service:Delete")) {
            $id = $this->_getParam("id");
            $obj_asitservice = new Application_Model_ServiceLogic($id);
            $obj_asitservice->set_service_status('D');
            $obj_asitservice->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Service Removed Successfully!!!";
            $this->_redirect("dynasty/service/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    
}
