<?php

class Dynasty_TeamController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Team:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_team = new Application_Model_TeamLogic(-1);
        echo $obj_team->fetchDataTableSelect();
    }

    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Team:Add")) {
            $obj_form = new Application_Form_Team();
            $this->view->form = $obj_form;
            $obj_team = new Application_Model_TeamLogic(-1);
            if($this->getRequest()->isPost()){
               $data=$this->getRequest()->getPost();
               if($obj_form->isValid($data)){
                 $obj_team->set_team_name($obj_form->team_name->getValue());
                 $obj_team->set_team_designation($obj_form->team_designation->getValue());
                 $obj_team->set_team_pic($obj_form->team_pic->getValue());
                 $obj_team->set_team_about($obj_form->team_about->getValue());
                 $obj_team->set_team_fb($obj_form->team_fb->getValue());
                 $obj_team->set_team_tweet($obj_form->team_tweet->getValue());
                 $obj_team->set_team_skype($obj_form->team_skype->getValue());
                 $obj_team->set_team_linkedin($obj_form->team_linkedin->getValue());
                 $obj_team->set_team_order($obj_form->team_order->getValue());
                 $obj_team->set_team_status('A');
                 $user = new Application_Model_UserLogic(-1);
                 $obj_team->set_team_created_by($user->getLoggedInUser()->get_id());
                 $obj_team->set_team_updated_by($user->getLoggedInUser()->get_id());
                 $obj_team->save();
                 
                 $sess = new Zend_Session_Namespace("msg");
                 $sess->msg = "Team Created Successfully!!!";
                 $this->_redirect("dynasty/team/index");
               }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Team:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam("id"));
            $obj_form = new Application_Form_Team();
            $obj_team = new Application_Model_Team($id);
            $obj_form->team_name->setValue($obj_team->get_team_name());
            $obj_form->team_designation->setValue($obj_team->get_team_designation());
            $obj_form->team_about->setValue($obj_team->get_team_about());
            $obj_form->team_fb->setValue($obj_team->get_team_fb());
            $obj_form->team_tweet->setValue($obj_team->get_team_tweet());
            $obj_form->team_skype->setValue($obj_team->get_team_skype());
            $obj_form->team_linkedin->setValue($obj_team->get_team_linkedin());
            $obj_form->team_order->setValue($obj_team->get_team_order());
            $obj_form->team_pic->setRequired(false);
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
              $data=$this->getRequest()->getPost();
              if($obj_form->isValid($data)){
                 $obj_team->set_team_name($obj_form->team_name->getValue());
                 $obj_team->set_team_designation($obj_form->team_designation->getValue());
                 if(count(explode('.', $obj_form->team_pic->getValue())) > 1) {
                    $obj_team->set_team_pic($obj_form->team_pic->getValue());
                 }
                 $obj_team->set_team_about($obj_form->team_about->getValue());
                 $obj_team->set_team_fb($obj_form->team_fb->getValue());
                 $obj_team->set_team_tweet($obj_form->team_tweet->getValue());
                 $obj_team->set_team_skype($obj_form->team_skype->getValue());
                 $obj_team->set_team_linkedin($obj_form->team_linkedin->getValue());
                 $obj_team->set_team_order($obj_form->team_order->getValue());
                 $obj_team->set_team_status('A');
                 $user = new Application_Model_UserLogic(-1);
                 $obj_team->set_team_updated_by($user->getLoggedInUser()->get_id());
                 $obj_team->save();
                 
                 $sess = new Zend_Session_Namespace("msg");
                 $sess->msg = "Team Updated Successfully!!!";
                 $this->_redirect("dynasty/team/index");
              }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Team:Delete")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam('id'));
            $obj_team = new Application_Model_Team($id);
            $obj_team->set_team_status('D');
            $obj_team->save();

            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Team Removed Successfully!!!";
            $this->_redirect("dynasty/team/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }


}

