<?php

class Dynasty_TestimonialController extends Zend_Controller_Action
{

    public function init()
    {
        /* Initialize action controller here */
        $this->_helper->layout()->setLayout('admin');
    }

    public function indexAction()
    {
        // action body
        if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Master")) {
            
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function jsonAction()
    {
        $this->_helper->layout()->disableLayout();
        $obj_testimonial = new Application_Model_TestimonialLogic(-1);
        echo $obj_testimonial->fetchDataTableSelect();
    }

    public function addAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Add")) {
            $obj_form = new Application_Form_Testimonial();
            $this->view->form = $obj_form;
            $obj_testimonial = new Application_Model_TestimonialLogic(-1);
            if($this->getRequest()->isPost()){
               $data=$this->getRequest()->getPost();
               if($obj_form->isValid($data)){
                    $obj_testimonial->set_testimonial_name($obj_form->testimonial_name->getValue());
                    $obj_testimonial->set_testimonial_company($obj_form->testimonial_company->getValue());
                    $obj_testimonial->set_testimonial_pic($obj_form->testimonial_pic->getValue());
                    $obj_testimonial->set_testimonial_content($obj_form->testimonial_content->getValue());
                    $obj_testimonial->set_testimonial_stars(5);
                    $obj_testimonial->set_testimonial_status('A');
                    $user = new Application_Model_UserLogic(-1);
                    $obj_testimonial->set_testimonial_created_by($user->getLoggedInUser()->get_id());
                    $obj_testimonial->set_testimonial_updated_by($user->getLoggedInUser()->get_id());
                    $obj_testimonial->save();

                    $sess = new Zend_Session_Namespace("msg");
                    $sess->msg = "Testimonial Created Successfully!!!";
                    $this->_redirect("dynasty/testimonial/index");
               }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }

    public function editAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Edit")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam("id"));
            $obj_form = new Application_Form_Testimonial();
            $obj_testimonial = new Application_Model_Testimonial($id);
            $obj_form->testimonial_name->setValue($obj_testimonial->get_testimonial_name());
			$obj_form->testimonial_company->setValue($obj_testimonial->get_testimonial_company());
			$obj_form->testimonial_pic->setValue($obj_testimonial->get_testimonial_pic());
			$obj_form->testimonial_content->setValue($obj_testimonial->get_testimonial_content());
            $obj_form->testimonial_pic->setRequired(false);
            $this->view->form = $obj_form;
            if($this->getRequest()->isPost()){
              $data=$this->getRequest()->getPost();
              if($obj_form->isValid($data)){
                $obj_testimonial->set_testimonial_name($obj_form->testimonial_name->getValue());
				 $obj_testimonial->set_testimonial_company($obj_form->testimonial_company->getValue());
                    if(count(explode('.', $obj_form->testimonial_pic->getValue())) > 1) {
                        $obj_testimonial->set_testimonial_pic($obj_form->testimonial_pic->getValue());
                    }
                 $obj_testimonial->set_testimonial_content($obj_form->testimonial_content->getValue());
                 $user = new Application_Model_UserLogic(-1);
                 $obj_testimonial->set_testimonial_updated_by($user->getLoggedInUser()->get_id());
                 $obj_testimonial->save();
                 
                 $sess = new Zend_Session_Namespace("msg");
                 $sess->msg = "Testimonial Updated Successfully!!!";
                 $this->_redirect("dynasty/testimonial/index");
              }
            }
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }
    
    public function deleteAction()
    {
        if(Application_Model_RolePermissionLogic::isPermitted("Testimonial:Delete")) {
            $enc = new Application_Model_Util_Encrypt();
            $id = $enc->showHiddenContent($this->_getParam('id'));
            $obj_testimonial = new Application_Model_Testimonial($id);
            $obj_testimonial->set_testimonial_status('D');
            $obj_testimonial->save();

            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Testimonial Removed Successfully!!!";
            $this->_redirect("dynasty/testimonial/index");
        }else {
            throw new Zend_Controller_Action_Exception(Application_Model_Cache_Config::getConfig('AUTHENTICATION_ERROR'), 404);
        }
    }


}

