<?php

class Manage_ClaimController extends Zend_Controller_Action
{

    public function init() {
        if(!Zend_Auth::getInstance()->hasIdentity()) {
            $sess = new Zend_Session_Namespace("msg");
            $sess->error = "Sorry, Your session has been logged out. Please Login again.";
            $this->_redirect('login');
        }
    }

    public function indexAction()
    {
        $cur_page=1;
        if($this->_getParam('page')!=null)
            $cur_page=(int)$this->_getParam('page');
        
        $query = $this->_getParam('query');
        
        $obj_claim = new Application_Model_ClaimLogic(-1);
        $results = $obj_claim->fetchOurClaims($query);
        
        $adapter = new Zend_Paginator_Adapter_DbSelect($results);
        
        $paginator = new  Zend_Paginator($adapter);
        
        
        $paginator->setItemCountPerPage(10);
        $paginator->setCurrentPageNumber($cur_page);
        
        $this->view->paginator = $paginator;
        
        Zend_Paginator::setDefaultScrollingStyle('Sliding');
            Zend_View_Helper_PaginationControl::setDefaultViewPartial(
                'pagination.phtml'
            );
            
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', 'My Claim Lists');
    }
    
    public function viewAction()
    {
        $id = $this->_getParam('id');
        $this->view->claim = $claim = new Application_Model_ClaimLogic($id);
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', 'Claim '.$claim->get_claim_num().' Information');
    }
}

