<?php

class Manage_DashboardController extends Zend_Controller_Action
{

    public function init()
    {
        if(!Zend_Auth::getInstance()->hasIdentity()) {
            $sess = new Zend_Session_Namespace("msg");
            $sess->error = "Sorry, Your session has been logged out. Please Login again.";
            $this->_redirect('login');
        }
    }

    public function indexAction()
    {
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', 'Dashboard');
        
        $obj_claim = new Application_Model_ClaimLogic(-1);
        $this->view->claim = $obj_claim->getDashboardCount();
        
        $obj_issue = new Application_Model_IssueLogic(-1);
        $this->view->issue = $obj_issue->getDashboardCount();
    }
    
}