<?php

class Manage_QueryController extends Zend_Controller_Action
{

    public function init() {
        if(!Zend_Auth::getInstance()->hasIdentity()) {
            $sess = new Zend_Session_Namespace("msg");
            $sess->error = "Sorry, Your session has been logged out. Please Login again.";
            $this->_redirect('login');
        }
    }

    public function indexAction()
    {
        $cur_page=1;
        if($this->_getParam('page')!=null)
            $cur_page=(int)$this->_getParam('page');
        
        $obj_query = new Application_Model_IssueLogic(-1);
        $results = $obj_query->fetchOurIssues();
        
        $adapter = new Zend_Paginator_Adapter_DbSelect($results);
        
        $paginator = new  Zend_Paginator($adapter);
        
        
        $paginator->setItemCountPerPage(10);
        $paginator->setCurrentPageNumber($cur_page);
        
        $this->view->paginator = $paginator;
        
        Zend_Paginator::setDefaultScrollingStyle('Sliding');
            Zend_View_Helper_PaginationControl::setDefaultViewPartial(
                'pagination.phtml'
            );
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', 'Queries / Feedbacks / Complaints');
    }
    
    public function addAction()
    {
        $obj_claim = new Application_Model_ClaimLogic(-1);
        $this->view->claims = $obj_claim->fetchAll($obj_claim->fetchOurClaims());
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', 'Add Query / Feedback / Complaint');
        
        if($this->getRequest()->isPost()){
            $data=$this->getRequest()->getPost();
            Zend_Debug::dump($data);
            $obj_user = new Application_Model_UserLogic(-1);
            $user = $obj_user->getLoggedInUser();
            $obj_issue = new Application_Model_IssueFileLogic(-1);
            $obj_issue->set_issue_title($data['issue_title']);
            $obj_issue->set_issue_description($data['issue_description']);
            $obj_issue->set_issue_type($data['issue_type']);
            $obj_issue->set_issue_claim_id($data['issue_claim_id']);
            $obj_claim = new Application_Model_ClaimLogic($data['issue_claim_id']);
            $obj_issue->set_issue_claim_num($obj_claim->get_claim_num());
            $obj_issue->set_issue_priority($data['issue_priority']);
            $obj_issue->set_issue_submit_type($user->get_user_type());
            $obj_issue->set_issue_submit_by($user->get_user_type_id());
            $obj_issue->set_issue_contact_name($data['issue_contact_name']);
            $obj_issue->set_issue_contact_email($data['issue_contact_email']);
            $obj_issue->set_issue_contact_phone($data['issue_contact_phone']);
            $obj_issue->set_issue_register_date(date('Y-m-d'));
            $obj_issue->set_issue_sync(0);
            $obj_issue->set_issue_created_by($user->get_id());
            $obj_issue->save();
            
            $sess = new Zend_Session_Namespace("msg");
            $sess->msg = "Ticket Submitted Successfully, We'll revert back shortly with ticket number!!!";
            $this->_redirect("manage/query/index");
        }
    }
    
    public function viewAction()
    {
        $id = $this->_getParam('id');
        $this->view->issue = $issue = new Application_Model_IssueLogic($id);
        
        $layout = $this->_helper->layout();
        $layout->assign('meta_key', 'select, control, panel, for, insured, surveyor, insurance, company'); 
        $layout->assign('meta_desc', 'Explore the claim status or raise query from your authenticated control panel. ');
        $layout->assign('page_title', $issue->get_issue_type().' '.$issue->get_issue_id().' Information');
    }
}

